/*
 * X interface for connX client
 */

#ifndef XCONN_H
#define XCONN_H

#include "connect.h"

int X_open (char *pDisplay_name);
int X_close ();
int X_allocate (game_start game_attr);
int X_deallocate ();
int X_get_player_move (coord * move);
int X_add_to_board (coord move, int player_num);
int X_bad_move ();
int X_game_end (int winner, coord start, coord end);
int X_handle_events ();
int X_show_turn (int player_no);

#define RESOURCE_FILE "/usr/lib/X11/app-defaults/Connx"

/* initial window attrib */
#define X_WIN 0
#define Y_WIN 0
#define WIN_WIDTH 600
#define WIN_HEIGHT 600
#define BORDER_WIDTH 2

/* font used if scalable font not found */
#define DISPLAY_FONT "9x15"

#define WINNER_STRING " is the WINNER!"
#define TIE_STRING "Tie game!"
#define CANCEL_STRING "Game has been cancelled!"
#define PLAYER_STRING "Players:"
#define TITLE_STRING "connX!!!"
#define TIME_STRING "Time left: "
#define QUIT -3

/*speed of animation = number of pixels piece is moved */
#define ANIM_PIXELS 5

#endif
