#define MAXPOINTS 256
#define MAXCOLOR 2048
#define CM_RED 0
#define CM_GREEN 1
#define CM_BLUE 2
#define CM_RAINBOW 3
#define CM_MONO 4
#define CM_STRIPE 6
#define CM_NOGREEN 7
#define CM_DEFAULT 8
#define MAX_CMAPS (CM_DEFAULT + 1)

#ifndef ALLOCATE_LOCAL
#define ALLOCATE_LOCAL(a) alloca(a)
#define DEALLOCATE_LOCAL(a)
#endif

typedef struct rubber_band_data_t {
	int start_x, start_y;
	int last_x, last_y;
	GC gc;
	} rubber_band_data_t;

typedef struct image_data_t {
	Widget toplevel;
	Widget area;
	int M, K;
	int max_color;
	GC gc;
	Pixmap pix;
	Colormap cmaps[MAX_CMAPS];
	Visual *visual;
	XSetWindowAttributes wndo_attributes;
	Dimension width, height;
	float ip_min, ip_max, iq_min, iq_max;
	double p_min, p_max, q_min, q_max;
	rubber_band_data_t rubber_band;
	XtWorkProcId work_proc;
	Boolean run_work_proc;
	Boolean rotate_forward;
	int rotate_jump_count;
	XColor *colors;
	Cursor normal_cursor;
	Cursor clock_cursor;
	Cursor band_cursor;
	int cm_current;
	void (*create_image)();
	} image_data_t, *image_data_ptr_t;
