.TH XBLOCKBUSTER 6 "16 November 1992"
.br
.SH NAME
xblockbuster \- game
.SH SYNOPSIS
.B xblockbuster
.I [play_ground]
.SH DESCRIPTION
The play ground is either the anonymous public play ground (no argument),
a named public playground or a privately owned directory.
The list of available named public play grounds is obtained by giving "-"
as the play ground argument.
.LP
The object of the game is to collect as many points as possible by
.I busting
through
.I blocks
of various types with a ball that reflects from the blocks and from a pallet
controlled by mouse movement.
.LP
The ball must be seen as a high-energy particle that penetrates the block
before being repelled.
If it gets repelled into another block it will find its own way out again.
This process, which often leads to surprises, is known as
.I tunnelling.
.br
(By design, tunnelling only occurs along a horizontal connection between blocks
or along the vertical sides, so never vertically between blocks.)
.LP
As the game progresses, balls are launched faster and faster.
When the speed has reached it maximum, the pallet is gradually,
though cumulatively, shrunk.
Be aware that the maximum launch speed (see below),
and hence the point from which the pallet is shrunk,
is only 2/3 of the speed limit, and the effect is much larger than that of
hitting a speeder (but of course you may hit them often).
.LP
The pallet is convex.
Hence reflection is a function of both the incoming angle and the excentricity
of the point of impact.
If the pallet is sufficiently convex (differs from stage to stage), the ball
may even rebound.
.LP
The mouse buttons control the pallet:
LEFT moves it up one row, MIDDLE moves it all the way down again.
Each ball is launched with the RIGHT mouse button.
.LP
A stage can be halted by closing the window, or moving the pointer out
of the window.
Be advised however, that the game will resume immediately upon opening the
window.
.LP
During a game, the score, number of balls left and speeds are shown.
The speeds are represented by up to 3 thin lines (one for each ball),
above a thick line representing the speed limit.
The short vertical bar indicates the launch speed
(black upon reaching the maximum launch speed, white below that).
If, during a stage, you have busted a 'double' or 'triple' brick, your
bonus multiplier will also be displayed at the top.
.LP
A game can be saved in between stages with the Escape key.
At this point, as well as at the end of the game, your score is logged.
The score board shows scores, number of balls left between parentheses if any
and user name.
Finally, an indication of your current pallet shrinkage is given.
.SH NOTES
.LP
In order to avoid infinite loops
(i.e., the ball(s) never reflecting from the pallet),
a ball will, upon hitting too many solid bricks,
undergo a horizontal shift,
proportional to, but opposite to the current horizontal speed.
.LP
The score board imposes a maximum on the number of entries for any given user
name.
If your current score didn't make it onto the score board,
it will be displayed at the bottom.
.LP
If a score entry is detected which obviously must have originated from a saved
game which for some reason "died", a `+' is appended and the entry will hence
forward be treated as any completed game.
.LP
A common problem players encounter is that of losing track of their mouse.
Be advised that mouse movement only alters the horizontal pallet position,
but the mouse of course may move vertically as well.
If your mouse is not neatly perpendicular to the reflection plate, you may
find yourself outside the window, halting play.
For this reason the horizontal crosshair is shown at the window border,
helping you to keep track of the mouse.
.SH "CREATION OF PLAY GROUNDS"
A private play ground can be created in any directory.
The stages can be defined from the ascii map codes using any text editor
They must be numbered consecutively from 0 with the total number
(i.e., one more than the highest number) available in the file nb_stages.
Furthermore a directory 'save' and an empty file 'scores' must be created.
.LP
Individual stages can be tried in the public play ground "try" (q.v. 'try'),
provided you have write access.
.SH "TYPES OF BLOCKS"
.sp
.nf
.na
CODE\h'|7m'NAME\h'|24m'REPRESENTATION
.sp
\&' ' \h'|7m'clear space\h'|24m'white
#\h'|7m'solid wall\h'|24m'black
/,\\\h'|7m'launchpad\h'|24m'black with arrow (like solid wall)
  The balls enters the stage diagonally at the tip of the arrow.
.SS BRICKS
.sp
0\h'|7m'solid brick\h'|24m'75% gray
  Scores 1 on each hit.
.sp
1-9\h'|7m'hit bricks\h'|24m'white with border (and slanted bars)
  Requires as many hits as their are bars (plus 1),
  each scoring equal to how often you have hit it.
  The stage is over when no such bricks remain.
.sp
a-e,j\h'|7m'bonus bricks\h'|24m'50% gray with value inscribed
  Requires value/10+1 hits before scoring.
.SS MAGIC
.sp
A\h'|7m'absorber\h'|24m'25% gray (no border)
^\h'|7m'emitter\h'|24m'black (like solid wall)
  The ball is absorbed and emitted (whilst being reflected).
.sp
C\h'|7m'clipper\h'|24m'pair of scissors between "> <"
  (On 2nd hit) Clips 10% off the pallet.
  By design, the remnants litter the screen!
  [Until the end of the current stage only.]
.sp
D\h'|7m'double\h'|24m'"double"
  (On 2nd hit) Doubles all subsequent hit values.
  [Until the end of the current stage only.]
.sp
E\h'|7m'extra ball\h'|24m'"+O+"
  (On 2nd hit) Adds an extra ball to the stock.
.sp
G\h'|7m'gap\h'|24m'the danger sign (! in a triangle)
  (On 2nd hit) The ball is lost.
  [As if it would have left the stage.]
.sp
H\h'|7m'halt\h'|24m'maze of small squares
  Successively takes 10, 20 and 30% of the speed.
.sp
I\h'|7m'invisible brick\h'|24m'white (like open space)
  Turns into a single hit brick when first hit, scoring 1.
.sp
L\h'|7m'launch ball\h'|24m'"=O="
  (On 2nd hit) Launches an extra ball.
  [Behaves like an 'extra ball' from 3 balls in game.]
.sp
M\h'|7m'mine\h'|24m'"kaboom" in dashed border
  (On 3rd hit) Blows up all adjacent bricks (no score);
  leaving debris 'refractor's.
.sp
P\h'|7m'pause\h'|24m'maze of small squares with launchpad images.
  (On 8th hit) Takes 30% of the excessive launch speed.
.sp
R\h'|7m'refractor\h'|24m'dashed border with crosses
  Interchanges motion along the axes.
.sp
S\h'|7m'speeder\h'|24m'concentric borders
  Adds speed (up to the speed limit; then pallet shrinkage).
.sp
T\h'|7m'triple\h'|24m'"triple"
  (On 3rd hit) Triples all subsequent hit values.
  [Until the end of the current stage only.]
.sp
U\h'|7m'undo\h'|24m'"undo"
  Restores the last block busted (with 0 hit count).
.sp
W\h'|7m'open window\h'|24m'bracketed set of vertical lines
%\h'|7m'closed window\h'|24m'black (like solid wall)
  Alternates between the two states upon each hit.
.sp
X\h'|7m'expander\h'|24m'a pallet image between "< >"
  (On 4th hit) Expands the pallet.
  [Equivalent to twice the full launch speed shrinkage.]
  [Effective in the next stage only.]

.fi
.ad
.SH X Defaults
.LP
The resource name
.I XBlockbuster
can be used to control the color the bricks to be displayed.  Each brick
has both a foreground and background color that can be displayed.  The
format is brick\fIcode\fP_fg or brick\fIcode\fP_bg.
.I code
represents the brick code, as detailed above.  Therefore a line such
as:
.LP
XBlockbuster.brick0_fg:		green

Makes the foreground color of the solid brick green.
.LP
In addition, the resource \fIalternate_bricks\fP
exists.  If selected,  alternate brick patterns will be used on color displays.
The alternate bricks tend to take coloring better than the standard bricks.
If you want to use alternate bricks, add the line:

XBlockbuster.alternate_bricks:  True

to your .Xdefaults file.
.LP
The coloring information and alternate brick request is ignored on
black and white systems.


.SH FILES
.nf
.na
stagemm\h'|30m'[optional] bookkeeping program

The location of the following is installation depedent.
stage.skel\h'|30m'skeleton stage
STAGES.\h'|30m'anonymous public play ground
STAGES.*\h'|30m'named public play grounds
\h'|30m'(including a try out environment)
XBlockbuster.ad\h'|30m'Sample Xdefaults for xblockbuster.
.fi
.ad

.SH BUGS
When two balls hit the same brick simultaneously,
one may leave a shadow on the stage.
.LP
Sometimes a ball image is left when the window is re-opened.
.LP
If the ball hits the bottom corners of the playing area, they will at times
reflect back in a reverse direction, instead of reflecting downward and
out of bounds.
.LP
XBlockbuster uses a public colormap for systems which use color.  If it is
unable to get all the colors it wants, it will use black and white for
the bricks it was unable to color.  If using alternate bricks, it can be
difficult to differentiate bricks without the coloring.
.LP
None of the standard command line X arguements are interperted.  Likewise,
none of the standard X defaults (in the .Xdefaults file) are used.
