typedef struct helpline {
   int xpos, ypos, page;
   char *textline;
} h_line;

h_line help_pages[] = {
  { 0, 35, 0, "Objective:  Push all the objects from their starting positions"},
  { 12, 50, 0, "into their goal positions.  Be warned that you can"},
  { 12, 65, 0, "push only one object at a time; watch out for corners!"},
  { 0, 100, 0, "Movement:   Use the vi-keys hjkl or the keyboard arrow keys"},
  { 25, 130, 0, "left right up down"},
  { 13, 145, 0, "Move/Push     h    l    k   j"},
  { 13, 160, 0, "Run/Push      H    L    K   J"},
  { 13, 175, 0, "Run Only     ^H   ^L   ^K  ^J"},
  { 0, 210, 0, "Commands:"},
  { 12, 210, 0, "^r: refresh screen            ?: get this help screen"},
  { 12, 225, 0, "^u: restore to temp save      c: make a temp save"}, 
  { 12, 240, 0, " u: undo last move/push       U: restart this level"},
  { 12, 255, 0, " s: save game and quit        q: quit game"},
  { 0, 285, 0, "Misc:       If you set a temp save, you need not undo all"},
  { 12, 300, 0, "when you get stuck.  Just reset to this save."},
  { 12, 330, 0, "A temporary save is automatically made at the start."},
  { 0, 380, 0, "Bitmaps:"},
  { 12, 380, 0, "Player:     Goal:      Wall:     Object:"},
  { 12, 420, 0, "Object on a goal:      Player on a goal:"},
  { 0, 35, 1, "                  Making your own bitmaps"},
  { 0, 65, 1, "The game expects various bitmaps to be present in the"},
  { 0, 80, 1, "directory you specify with -b.  The following are the"},
  { 0, 95, 1, "correspondences between files and game objects:"},
  { 0, 110, 1, "   man.xbm      -- The player bitmap"},
  { 0, 125, 1, "   goal.xbm     -- The bitmap for the goal"},
  { 0, 140, 1, "   wall.xbm     -- The generic wall bitmap"},
  { 0, 155, 1, "   object.xbm   -- Bitmap for the object you push around"},
  { 0, 170, 1, "   treasure.xbm -- Bitmap for an object on the goal"},
  { 0, 185, 1, "   saveman.xbm  -- Bitmap for man on a goal position"},
  { 0, 200, 1, "If you use the -w option (for fancy walls), the following"},
  { 0, 215, 1, "bitmaps are also needed:"},
  { 0, 230, 1, "   southwall.xbm    -- wall with only northern connections"},
  { 0, 245, 1, "   northwall.xbm    -- wall with only southern connections"}, 
  { 0, 260, 1, "   eastwall.xbm     -- wall with only western connections"}, 
  { 0, 275, 1, "   westwall.xbm     -- wall with only eastern connections"}, 
  { 0, 290, 1, "   llcornerwall.xbm -- Lower left hand corner wall"},
  { 0, 305, 1, "   ulcornerwall.xbm -- Upper left hand corner wall"}, 
  { 0, 320, 1, "   lrcornerwall.xbm -- Lower right hand corner wall"},
  { 0, 335, 1, "   urcornerwall.xbm -- Upper right hand corner wall"}, 
  { 0, 350, 1, "   north_twall.xbm  -- connects to south, east, and west"},
  { 0, 365, 1, "   south_twall.xbm  -- connects to north, east, and west"},
  { 0, 380, 1, "   east_twall.xbm   -- connects to north, south, and west"},
  { 0, 395, 1, "   west_twall.xbm   -- connects to north, south, and east"},
  { 0, 410, 1, "   centerwall.xbm   -- connects to walls on every side"},
  { 0, 425, 1, "   lonewall.xbm     -- connects to walls on no sides"},
  { 0, 440, 1, "If you do not have a saveman.xbm, it will try to load man.xbm"},
  { 0, 455, 1, "and if you use -w and a wall file is missing, it will try to"},
  { 0, 470, 1, "load wall.xbm."},
  { 0, 485, 1, "All loading takes place in the following order:"},
  { 0, 500, 1, "  bitmap from -b dir (if -b specified)"},
  { 0, 515, 1, "  alternate from -b dir (if -b specified, and there is an"},
  { 0, 530, 1, "    alternate (see saveman.xbm and -w wall bitmaps))"},
  { 0, 545, 1, "  default bitmap"},
  { 0, 560, 1, "  default alternate if one exists"},
  {0, 0, 0, NULL}
};
