/***********************************************************************
   You may wish to alter the following directory paths
***********************************************************************/
/**/
/* SCREENPATH: the name of the directory where the screen file are held */
/**/
#define SCREENPATH "/usr/games/lib/xsokoban/screens"

/**/
/* SAVEPATH: the name of the path where save files are held */
/*           Attention: Be sure that there are no other files with */
/*                      the name <username>.sav                    */
/**/
#define SAVEPATH "/usr/games/lib/xsokoban/saves"

/* BITPATH: the full pathname to the bitmap file defaults. */
#define BITPATH "/usr/games/lib/xsokoban/bitmaps"

/**/
/* LOCKPATH: temporary file which is created to ensure that no users */
/*           work with the scorefile at the same time                */
/**/
#define LOCKFILE "/tmp/score.slock"

/**/
/* SCOREFILE: the full pathname of the score file */
/**/
#define SCOREFILE "/usr/games/lib/xsokoban/scores"

/**/
/* MAXUSERNAME: defines the maximum length of a system's user name */
/**/
#define MAXUSERNAME	32

/**/
/* MAXSCOREENTRIES: defines the maximum numner of entries in the scoretable */
/**/
#define MAXSCOREENTRIES	10000

/**/
/* SUPERUSER: defines the name of the game superuser */
/**/
#define SUPERUSER "iv"

/**/
/* PASSWORD: defines the password necessary for creating a new score file */
/**/
#define PASSWORD "right"

#ifdef VICE
extern int PlayerUID;
#define getuid() PlayerUID
#define geteuid() PlayerUID
#endif

/**/
/* OBJECT: this typedef is used for internal and external representation */
/*         of objects                                                    */
/**/

#define BUFSIZE 256

/**/
/* Attention: Do not alter the following defines. */
/* This would cause an error when reading the screenfiles */
/**/
#define   player	'@'
#define   playerstore	'+'
#define   store		'.'
#define   packet	'$'
#define   save		'*'
#define   ground	' '
#define   wall		'#'

/*************************************************************************
********************** DO NOT CHANGE BELOW THIS LINE *********************
*************************************************************************/
#define MAXROW		20
#define MAXCOL		20

typedef struct {
   short x, y;
} POS;

#define E_FOPENSCREEN	1
#define E_PLAYPOS1	2
#define E_ILLCHAR	3
#define E_PLAYPOS2	4
#define E_TOMUCHROWS	5
#define E_TOMUCHCOLS	6
#define E_ENDGAME	7
#define E_NOUSER	9
#define E_FOPENSAVE	10
#define E_WRITESAVE	11
#define E_STATSAVE	12
#define E_READSAVE	13
#define E_ALTERSAVE	14
#define E_SAVED		15
#define E_TOMUCHSE	16
#define E_FOPENSCORE	17
#define E_READSCORE	18
#define E_WRITESCORE	19
#define E_USAGE		20
#define E_ILLPASSWORD	21
#define E_LEVELTOOHIGH	22
#define E_NOSUPER	23
#define E_NOSAVEFILE	24
#define E_NOBITMAP	25
#define E_NODISPLAY	26
#define E_NOFONT	27
#define E_NOMEM		28
#define E_NOCOLOR	29
