#  CHK=0xD0E9
#+-------------------------------------------------------------------
#  Makefile for u386mon for SCO UNIX V/386
#  wht@n4hgf.Mt-Park.GA.US
#--------------------------------------------------------------------
#+:EDITS:*/
#:06-30-1995-19:50-guym@sco.com-SCO 3.2.5 support added: -DSCO325 & elf
#:08-26-1993-04:48-wht@fep-x2.74 includes 88k32
#:08-03-1993-17:47-belal@sco-added -DVPIX, removed mips header dependencies
#:08-03-1993-15:51-wht@n4hgf-source control point x2.70
#:07-02-1993-20:02-wht@n4hgf-correct library order
#:07-02-1993-19:30-wht@n4hgf-32v4 compiler switches
#:07-15-1992-14:31-wht@n4hgf-2.60 release - u386mon+siotools merge
#:04-07-1992-11:55-wht@n4hgf-remove -fcombine-regs for gcc 2.1
#:08-01-1991-23:34-wht@n4hgf-release 2.53 source control point
#:05-09-1991-03:51-wht@n4hgf-gcc support
#:04-16-1991-02:24-martin@hppcmart-additions for SCO 3.2.2
#:04-15-1991-16:05-martin@hppcmart-add table/wd/streams for SCO
#:08-10-1990-14:12-jmd@p1so/wht@n4hgf-2.20-add Tandem Integrity S2
#:08-07-1990-14:24-wht@n4hgf-nba@sysware.dk SVR31 updates
#:08-02-1990-15:35-wht@n4hgf-2.12-old curses hacks+minor 3.2 formalizations
#:08-01-1990-21:39-wht@n4hgf-add Dell make file
#:08-01-1990-12:26-wht@n4hgf-2.11-try to support ISC 1.x.x
#:07-28-1990-18:07-wht@n4hgf-2.10 release
#:07-26-1990-02:55-wht@n4hgf-add -nointl -- smaller + we don't use it
#:07-24-1990-18:53-wht@n4hgf-add USIZE_FIXED reminder
#:07-21-1990-16:03-wht@n4hgf-add libpanel + remake depend
#:06-30-1990-19:06-wht@n4hgf-run nlsym using full pathname
#:06-27-1990-01:57-wht@n4hgf-1.10 - incorporate suggestions from alpha testers
#:06-25-1990-04:14-wht@n4hgf-1.03-better error handling
#:06-21-1990-14:27-r@n4hgf-version x0.12 seems bug free
#:06-19-1990-21:37-wht@n4hgf-get ready for 0.08 release

#------------> CFLAGS_LOCAL
# Use -DVPIX         if you have kernel support for VP/ix
#                    whether installed or not
# Use -DMERGE386
#                    if you have kernel support for Merge/386 (ODT-DOS)
#                    whether installed or not
#
# Use -DUSIZE_FIXED  if you get erroneous process sizes (leave off for 3.2.0;
#                    you do want this for any UNIX after 3.2.0 or any ODT)
#
# Use -DSCO322       if you are using SCO version 3.2.2 (UNIX 3.2r2 or ODT 1.1)
#                    or later
#
# Use -DSCO325       if you are using SCO version 3.2.5 (OpenServer Relase 5.0)
#                    or later
#
CFLAGS_LOCAL = -DSCO322 -DVPIX -DMERGE386 -DUSIZE_FIXED #-DSIO_IS_FAS
CFLAGS_LOCAL = -DSCO325 -DSCO322  -DVPIX -DMERGE386 -DUSIZE_FIXED #-DSIO_IS_FAS

#------------> compiler choice (CC, CFLAGS, LDFLAGS)
#--> cc (native MSC 5.x)
CC = cc
# CFLAGS = -c $(CFLAGS_LOCAL) -O -D_NO_PROTOTYPE -D_SVID -D_KR
CFLAGS =  -b elf -c $(CFLAGS_LOCAL) -O  -D_SVID 
LDFLAGS = 

#--> gcc (some people make their gcc predefine 'i386' but others do not)
#        You'll get bad explosions with -pedantic -ansi' unless you've
#        hacked your header files to remove #idents plus some other changes.
#        You probably want to substitute -traditional (I like GccAbuse).
#CC = gcc
#CFLAGS = -c $(CFLAGS_LOCAL)\
#	-traditional -O -g\
#	-D_KR -D_SVID -D_NO_PROTOTYPES\
#	-fstrength-reduce -fpcc-struct-return -fwritable-strings\
#	-finline-functions -fforce-mem -fforce-addr\
#	-DM_UNIX -DM_XENIX -DM_SYSV -DM_SYS5 -DM_I386 -Di386
#LDFLAGS = -g

#------------> LIB
LIB = -lpanel -ltinfo -lmalloc -lc_s -lc -lx

#------------> KMEMGRP
KMEMGRP = mem

#------------> BINDIR
BINDIR = /usr/local/bin

VERSION = x2.74

#handle Sys V make "feature" of using SHELL
SHELL = /bin/sh

#FCRC = fcrc -u $*.c ;
.c.o:
	@echo ignore any redefinition warnings for box and newterm;
	$(FCRC) $(CC) $(CFLAGS) $*.c 

SRC =\
	u386mon.c\
	colormgt.c\
	bootinfo.c\
	detail.c\
	det_proc.c\
	det_sio.c\
	det_stream.c\
	det_table.c\
	det_wd.c\
	disputil.c\
	kludge.c\
	libkmem.c\
	libmem.c\
	libpanel.c\
	libswap.c\
	libnlsym.c\
	nlsym.c\
	proc.c\
	tune.c\
	var.c

HDR =\
	config.h\
	libkmem.h\
	libmem.h\
	libpanel.h\
	libswap.h\
	libnlsym.h\
	lint_args.h\
	nlsym.h\
	patchlevel.h\
	ttynm.h\
	u386mon.h

NLSYM_OBJ =\
	nlsym.o

U386MON_OBJ =\
	u386mon.o\
	colormgt.o\
	detail.o\
	det_proc.o\
	det_sio.o\
	det_stream.o\
	det_table.o\
	det_wd.o\
	bootinfo.o\
	kludge.o\
	proc.o\
	tune.o\
	var.o\
	disputil.o\
	libkmem.o\
	libmem.o\
	libswap.o\
	libnlsym.o

SHARFLS =\
	README\
	CHANGES\
	Make.*\
	EXPLAIN\
	U386monrc\
	$(SRC)\
	$(HDR)\
	renice/Makefile\
	renice/renice.c\
	panel/README\
	panel/panel.3\
	panel/ptest.c\
	panel/Makefile\
	siotools/Makefile\
	siotools/README\
	siotools/kmemsio.c\
	siotools/kmemsio.h\
	siotools/siomon.c\
	siotools/utoa.c\
	siotools/utoa.h\
	siotools/uusnap.c\
	siotools/wingets.c\
	siotools/wintio.c\
	siotools/wintio.h\
	siotools/wintty.c\
	siotools/wintty.h

all: nlsym u386mon

#must run as root
install: all
	cp u386mon $(BINDIR)
	-if [ -x /usr/bin/mcs ]; then /usr/bin/mcs -d $(BINDIR)/u386mon; fi
	strip $(BINDIR)/u386mon
	chown root $(BINDIR)/u386mon
	chgrp uucp $(BINDIR)/u386mon
	chmod 4111 $(BINDIR)/u386mon
	cp nlsym $(BINDIR)
	-if [ -x /usr/bin/mcs ]; then /usr/bin/mcs -d $(BINDIR)/nlsym; fi
	strip $(BINDIR)/nlsym
	chown root $(BINDIR)/nlsym
	chgrp uucp $(BINDIR)/nlsym
	chmod 4111 $(BINDIR)/nlsym
	$(BINDIR)/nlsym
	@echo ' ';echo 'csh users rehash before executing'

nlsym: $(NLSYM_OBJ)
	$(CC) $(LDFLAGS) -o $@ $(NLSYM_OBJ) $(LIB)

u386mon: $(U386MON_OBJ)
	$(CC) $(LDFLAGS) -o $@ $(U386MON_OBJ) $(LIB)

/unix.nlsym: nlsym /unix
	$(BINDIR)/nlsym
	chmod 644 /unix.nlsym

#not delivered
src.fls: $(SRC) Makefile
	ls $(SRC) > src.fls
lint_args: src.fls
	echo ' ' > lint_args.h
	csh zgcc src.fls lint_args.h $(CFLAGS)

neat:
	rm -f *\# *~ *.orig *.rej *.out *.log core ,* cscope.out tags *.bak \
		mkdep.* *.new src.fls u386mon.lint

clean: neat
	rm -f $(U386MON_OBJ) $(NLSYM_OBJ)

clobber: clean
	rm -f nlsym u386mon

lint:
	lint -ux *.c > u386mon.lint

#for shar 3.27 or later
shar:
	shar -a -n u386mon.$(VERSION) -l 55 -o u386m-$(VERSION) $(SHARFLS)

# MAKE DEPEND: regenerate .c:.h, .ol:.c, .ol:.asm dependencies automatically
#
depend:
		rm -f mkdep.rule.tmp
		if test '$(SRC)' ;\
		then (grep '^#include' $(SRC)\
			-e 's?:[^"]*"\([^"]*\)".*?:\1?'\
			-e 's?\(.*\)\.c?\1.o?'\
		 >> mkdep.rule.tmp) ;\
		fi

		echo 1 >mkdep.ex.tmp
		echo '/^# DO NOT DELETE THIS LINE' >>mkdep.ex.tmp
		echo '.+1,$$d' >>mkdep.ex.tmp
		echo 'r mkdep.rule.tmp' >> mkdep.ex.tmp
		echo 'w' >> mkdep.ex.tmp
		cp Make.sco Make.sco.new
		ex Make.sco.new < mkdep.ex.tmp
		rm mkdep.ex.tmp mkdep.rule.tmp
		echo '#	DEPENDENCIES MUST END AT END OF	FILE' >>Make.sco.new
		echo '#	IF YOU PUT STUFF HERE IT WILL GO AWAY'>>Make.sco.new
		echo '#	see make depend	above'>>Make.sco.new
		mv Make.sco Make.sco.bak
		mv Make.sco.new Make.sco
		@echo Make.sco has been updated with dependencies

# DO NOT DELETE THIS LINE
u386mon.o:config.h
u386mon.o:patchlevel.h
u386mon.o:libpanel.h
u386mon.o:nlsym.h
u386mon.o:libkmem.h
u386mon.o:libmem.h
u386mon.o:libswap.h
u386mon.o:libnlsym.h
u386mon.o:u386mon.h
bootinfo.o:config.h
bootinfo.o:libpanel.h
bootinfo.o:u386mon.h
detail.o:config.h
detail.o:libpanel.h
detail.o:nlsym.h
detail.o:libkmem.h
detail.o:libnlsym.h
detail.o:u386mon.h
det_proc.o:config.h
det_proc.o:libpanel.h
det_proc.o:nlsym.h
det_proc.o:libkmem.h
det_proc.o:libmem.h
det_proc.o:libswap.h
det_proc.o:libnlsym.h
det_proc.o:u386mon.h
det_sio.o:config.h
det_sio.o:libpanel.h
det_sio.o:nlsym.h
det_sio.o:libkmem.h
det_sio.o:libmem.h
det_sio.o:libswap.h
det_sio.o:libnlsym.h
det_sio.o:u386mon.h
det_sio.o:ttynm.h
det_stream.o:config.h
det_stream.o:libpanel.h
det_stream.o:nlsym.h
det_stream.o:libkmem.h
det_stream.o:libmem.h
det_stream.o:libswap.h
det_stream.o:libnlsym.h
det_stream.o:u386mon.h
det_table.o:config.h
det_table.o:libpanel.h
det_table.o:nlsym.h
det_table.o:libkmem.h
det_table.o:libmem.h
det_table.o:libswap.h
det_table.o:libnlsym.h
det_table.o:u386mon.h
det_wd.o:config.h
det_wd.o:libpanel.h
det_wd.o:nlsym.h
det_wd.o:libkmem.h
det_wd.o:libmem.h
det_wd.o:libswap.h
det_wd.o:libnlsym.h
det_wd.o:u386mon.h
disputil.o:config.h
disputil.o:libpanel.h
disputil.o:u386mon.h
libkmem.o:libkmem.h
libmem.o:libmem.h
libpanel.o:config.h
libpanel.o:u386mon.h
libswap.o:libswap.h
libnlsym.o:config.h
libnlsym.o:nlsym.h
libnlsym.o:libnlsym.h
nlsym.o:config.h
nlsym.o:nlsym.h
proc.o:config.h
proc.o:libpanel.h
proc.o:nlsym.h
proc.o:libkmem.h
proc.o:libnlsym.h
proc.o:u386mon.h
tune.o:config.h
tune.o:libpanel.h
tune.o:u386mon.h
var.o:config.h
var.o:libpanel.h
var.o:u386mon.h
#	DEPENDENCIES MUST END AT END OF	FILE
#	IF YOU PUT STUFF HERE IT WILL GO AWAY
#	see make depend	above
