///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//         This example code is from the book:
//
//           Object-Oriented Programming with C++ and OSF/Motif
//         by
//           Douglas Young
//           Prentice Hall, 1992
//           ISBN 0-13-630252-1	
//
//         Copyright 1991 by Prentice Hall
//         All Rights Reserved
//
//  Permission to use, copy, modify, and distribute this software for 
//  any purpose except publication and without fee is hereby granted, provided 
//  that the above copyright notice appear in all copies of the software.
///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////
// labeltest.C,
////////////////////////////////////////////////////////

#include <Xm/Xm.h>
#include "LabeledText.h"

#if (XlibSpecificationRelease>=5)
void main ( int argc, char **argv )
#else
void main ( unsigned int argc, char **argv )
#endif
{
    Widget       toplevel;
    Display     *dpy;
    XtAppContext app;
    
    // Initialize the Intrinsics
    
    XtToolkitInitialize();

    // Create an application context
    
    app = XtCreateApplicationContext();
    
    // Open a connection to the X server
    
    dpy = XtOpenDisplay ( app, NULL, NULL, 
                         "Pushme", 
                         NULL, 0, 
                         &argc, argv );
    
    // Create a toplevel shell
    
    toplevel = XtAppCreateShell ( NULL, "Hello", 
                                 applicationShellWidgetClass,
                                 dpy, NULL, 0 );
    
    LabeledText *lt = new LabeledText(toplevel, "labeledText");
    
    // Realize all widgets and enter the main event loop
    
    XtRealizeWidget ( toplevel );
    
    XtAppMainLoop ( app );
}

