/*
 * Copyright (C) 1990-1992 Michael Davidson.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies and that both that copyright notice and this permission
 * notice appear in supporting documentation.
 *
 * This software is provided "as is" without express or implied warranty.
 */

#ifndef	IMAGE_H
#define	IMAGE_H

struct	image
{
    int			width;
    int			height;
    int			depth;
    int			bytes_per_pixel;
    unsigned char	**pixels;
};

typedef struct image	image_t;

extern int	imageInit();
extern image_t	*imageStart(char *name, int w, int h, int d, int bg);
extern int	imagePutPixels(int x, int y, void *p, int n);
extern int	imagePutPixelsRGB(int x, int y, void *p, int n);
extern int	imageEnd();
extern int	imageGetKey(int delay);
extern int	imageWarning(char *fmt, ...);
extern int	imageError(char	*fmt, ...);

extern image_t	*Image;

#endif
