/*
 * Copyright (C) 1990 by Michael Davidson.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies and that both that copyright notice and this permission
 * notice appear in supporting documentation.
 *
 * This software is provided "as is" without express or implied warranty.
 */

#ifndef	TEXT_H
#define	TEXT_H

/*
 * text.h - defines for text mode stuff
 */

/*
 * PC graphics characters
 */
#ifdef	PC_GRAPHICS

#define TOP_LEFT_CORNER		0xda
#define	TOP_RIGHT_CORNER	0xbf
#define	BOT_LEFT_CORNER		0xc0
#define	BOT_RIGHT_CORNER	0xd9

#define	HORIZONTAL_LINE		0xc4
#define	VERTICAL_LINE		0xb3

#define	RIGHT_TEE		0xb4
#define	LEFT_TEE		0xc3
#define	TOP_TEE			0xc2
#define	BOT_TEE			0xc1

#define	DBL_TOP_LEFT_CORNER	0xc9
#define	DBL_TOP_RIGHT_CORNER	0xbb
#define	DBL_BOT_LEFT_CORNER	0xc8
#define	DBL_BOT_RIGHT_CORNER	0xbc

#define	DBL_HORIZONTAL_LINE	0xcd
#define	DBL_VERTICAL_LINE	0xba

#define	DBL_RIGHT_TEE		0xb9
#define	DBL_LEFT_TEE		0xcc
#define	DBL_TOP_TEE		0xcb
#define	DBL_BOT_TEE		0xca

#else

#define TOP_LEFT_CORNER		'+'
#define	TOP_RIGHT_CORNER	'+'
#define	BOT_LEFT_CORNER		'+'
#define	BOT_RIGHT_CORNER	'+'

#define	HORIZONTAL_LINE		'-'
#define	VERTICAL_LINE		'|'

#define	RIGHT_TEE		'+'
#define	LEFT_TEE		'+'
#define	TOP_TEE			'+'
#define	BOT_TEE			'+'

#endif

/*
 * PC text mode colors
 */

#define	BLACK		0x0
#define	BLUE		0x1
#define	GREEN		0x2
#define	CYAN		0x3
#define	RED		0x4
#define	MAGENTA		0x5
#define	BROWN		0x6
#define	WHITE		0x7
#define	GRAY		0x8
#define	LT_BLUE		0x9
#define	LT_GREEN	0xA
#define	LT_CYAN		0xB
#define	LT_RED		0xC
#define	LT_MAGENTA	0xD
#define	YELLOW		0xE
#define	HI_WHITE	0xF

#endif	/* TEXT_H */
