/*
 * Copyright (C) 1992 by Michael Davidson.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies and that both that copyright notice and this permission
 * notice appear in supporting documentation.
 *
 * This software is provided "as is" without express or implied warranty.
 */

#ifndef	IBM8514_H
#define	IBM8514_H

/*
 * ibm8514.h	- register definitions for IBM 8514 and compatibles
 */

/*
 * 8514 registers
 */
#define	DAC_MASK	0x02ea
#define	DAC_R_INDEX	0x02eb
#define	DAC_W_INDEX	0x02ec
#define	DAC_DATA	0x02ed

#define	DISP_STAT	0x02e8
#define	H_TOTAL		0x02e8
#define	H_DISP		0x06e8
#define	H_SYNC_STRT	0x0ae8
#define	H_SYNC_WID	0x0ee8
#define	V_TOTAL		0x12e8
#define	V_DISP		0x16e8
#define	V_SYNC_STRT	0x1ae8
#define	V_SYNV_WID	0x1ee8
#define	DISP_CNTL	0x22e8

#define	ADVFUNC_CNTL	0x4ae8
#define	SUBSYS_STAT	0x42e8
#define	SUBSYS_CNTL	0x42e8
#define	ROM_PAGE_SEL	0x46e8

#define	CUR_Y		0x82e8
#define	CUR_X		0x86e8
#define	DESTY_AXSTP	0x8ae8
#define	DESTX_DIASTP	0x8ee8
#define	ERR_TERM	0x92e8
#define	MAJ_AXIS_PCNT	0x96e8
#define	GP_STAT		0x9ae8
#define	CMD		0x9ae8
#define	SHORT_STROKE	0x9ee8
#define	BKGD_COLOR	0xa2e8
#define	FRGD_COLOR	0xa6e8
#define	WRT_MASK	0xaae8
#define	RD_MASK		0xaee8
#define	COLOR_CMP	0xb2e8
#define	BKGD_MIX	0xb6e8
#define	FRGD_MIX	0xbae8

#define	MULTIFUNC_CNTL	0xbee8
#define	MIN_AXIS_PCNT	0x0000
#define	SCISSORS_T	0x1000
#define	SCISSORS_L	0x2000
#define	SCISSORS_B	0x3000
#define	SCISSORS_R	0x4000
#define	MEM_CNTL	0x5000
#define	PATTTERN_L	0x8000
#define	PATTTERN_R	0x9000
#define	PIX_CNTL	0xa000

#define	PIX_TRANS	0xe2e8

/*
 * wait for command queue to clear
 */

#define WAIT_QUEUE(n) \
{ \
	register int mask; \
	mask = 0x100 >> (n); \
	while (mask & inw(GP_STAT)); \
}
#endif	/* IBM8514_H */
