/*
 * Copyright (C) 1990-1992 Michael Davidson.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies and that both that copyright notice and this permission
 * notice appear in supporting documentation.
 *
 * This software is provided "as is" without express or implied warranty.
 */

#ifndef	KBD_H
#define	KBD_H

/*
 * defines for some standard ascii values
 */
#define	K_ESCAPE	0x1b
#define	K_ENTER		0x0d
#define	K_BACKSPACE	0x08
#define	K_TAB		0x09
#define	K_NEWLINE	0x0a
#define	K_SPACE		0x20

/*
 * defines for function keys and cursor keys
 */
#define	K_UP		0x101
#define	K_DOWN		0x102
#define	K_LEFT		0x103
#define	K_RIGHT		0x104
#define	K_HOME		0x105
#define	K_END		0x106
#define	K_PG_UP		0x107
#define	K_PG_DN		0x108
#define	K_INS		0x109
#define	K_DEL		0x10a
#define	K_MINUS		0x10b
#define	K_PLUS		0x10c
#define	K_5		0x10d

#define	FUNC(x)		((x) | 0x200)
#define	CTRL(x)		((x) | 0x400)
#define	SHIFT(x)	((x) | 0x800)
#define	ALT(x)		((x) | 0x1000)

#define	K_WAIT		-1
#define	K_NOWAIT	0

void	kbdInit();
void	kbdReset();
int	kbdGetKey(int);
void	kbdBell();

#endif	/* KBD_H */
