.\" @(#)xprompt	2.0 10/29/90; Copyright (c) 1990 Michael Murphy and Robert Forsman
.TH XPROMPT 1 "29 Oct 1990" "Non-Proprietary X"
.SH NAME
xprompt \- Athena toolkit program to prompt for input in an X window

.IX xprompt#(1) "" "\fLxprompt\fP(1)"
.SH SYNOPSIS
.B xprompt
[
.BI -display " dsp"
]
[
.BI -p promptstring
[
.BI -r defaultreply
]
]
[
.BI -rlen
]
[
.BI -ibw
]
[
.BI -grab/-nograb
]
[
.BI -pfn
]
[
.BI -rfn
]
[
.BI -hl
]

.SH DESCRIPTION
.B xprompt
opens an X window and accepts single lines of input from the user.

Invoke
.B xprompt
with as many \fI-p\fPs as you have fields.
For each \fI-p\fP you may specify a \fI-r\fP for a default reply.
The default reply will be inserted into the reply field and the user
will be able to edit it with the normal Athena text-widget keys.

If no arguments are given, a default prompt of "?" is given and the
user will have a blank reply field.

Pressing <Return> or ^M will advance the input focus highlight to the
next field.  <Return> and ^M will exit the program normally if pressed
in the last field.  Pressing ^N or <Tab> will advance the highlight to
the next field but wrap back to the top if in the last field.  Pressing
^P or <Shift><Tab> will take the input focus to the previous field,
wrapping to the bottom if the focus is in the first field.

Upon normal exit the program prints out what is in each of the fields
onto stdout.  Different fields are in order on different lines.
If the user presses ^C at any time, xprompt will exit and print nothing.

.SH OPTIONS
.TP 5
.B \-display " dpy:n.m"
The
.I display
option sets the X11 display to prompt for input on.

.TP 5
.B \-rlen " replylength"
The
.I rlen
option sets the reply length for all the fields to
.I replylength
characters.

.TP 5
.B \-ibw " w"
This sets the internal borderWidth for all the input text-widgets.
It is retained because the original xprompt had it (I think).

.TP 5
.B \-grab
.TP 5
.B \-nograb
xprompt normally grabs the keyboard.  Other programs will not be
able to recieve keyboard input until the user exits xprompt.
.B -nograb
will allow other programs to recieve keyboard input, but the user
will then have to focus keyboard input on xprompt like a normal
application to be able to type in it.

.TP 5
.B \-pfn " fontspec"
sets the font for the prompts.

.TP 5
.B \-rfn " fontspec"
sets the font for the reply fields.

.TP 5
.B \-hl " color"
sets the color for the highlight of the active field, normally white.

.TP 5
.B \-p " prompt"
specifies a prompt for a field.

.TP 5
.B \-r " reply"
specifies a reply that will be inserted into the field
for the user to edit.

.SH BUGS
The default does not look good on a monochromes screen.  Try

.DS
xprompt -p what -p too -p do -xrm "*input.borderColor:white" -hl black
.DE


.SH SEE ALSO
X(1), Xlib,Xt,Xaw Documentation.
.SH AUTHOR
 Michael Murphy		(mjm@cis.ufl.edu)
  -and-
 Robert Forsman		(thoth@cis.ufl.edu)
 University of Florida
 Department of Computer Science
 and other places.

.SH COPYRIGHT
Copyright (c) 1990 by Michael Murphy and Robert Forsman.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
