.TH XWALLD 1 "Release 4" "X Version 11"
.SH NAME
xwalld - X wall message daemon
.SH SYNOPSIS
\fBxwalld\fP [ \fI-toolkitoption\fP ...]
[-[no]bell] [-[no]notify] [-[no]raise]
.SH DESCRIPTION
The \fIxwalld\fP daemon collects and displays wall messages in a popup window.
Whenever a message arrives, xwalld rings the bell, raises the appropriate
window and
displays the new message.  Previous messages can be viewed by using the
scroll bar.
.PP
\fIXwalld\fP is designed to run continually.
If a user wants his X resources to apply, he can start a new
copy of \fIxwalld\fP.
The old \fIxwalld\fP will quietly exit.
.SH OPTIONS
The \fIxwalld\fP program accepts the standard X Toolkit command 
line options as well as the following:
.TP 8
.B \-bell
This option indicates that the bell should
be rung whenever a message arrives.
This is the default behavior.
.TP 8
.B \-nobell
This option indicates that the bell should
not be rung whenever a message arrives.
.TP 8
.B \-notify
This option indicates that an asterisk should
be appended to the icon name whenever a message arrives.
This is the default behavior.
.TP 8
.B \-nonotify
This option indicates that an asterisk should
not be appended to the icon name whenever a message arrives.
.TP 8
.B \-raise
This option indicates that the message window should
be deiconified and raised whenever a message arrives.
This is the default behavior.
.TP 8
.B \-noraise
This option indicates that the message window should
not be deiconified and raised whenever a message arrives.
.SH RESOURCES
The program understands all of the core X Toolkit resource names and
classes as well as:
.\".in +1in
.TP 8
.B "bell (\fPclass\fB Bell)"
Specifies whether or not \fIxwalld\fP rings the bell when a message arrives.
.TP 8
.B "notify (\fPclass\fB Notify)"
Specifies whether or not \fIxwalld\fP appends an asterisk to the icon name
when a message arrives.
.TP 8
.B "openDelay (\fPclass\fB OpenDelay)"
Specifies the time to wait (in seconds) before restarting
after losing the connection to the X server.  The default is 15 seconds.
.TP 8
.B "pingInterval (\fPclass\fB PingInterval)"
To discover when remote displays disappear,
.I xwalld
occasionally "pings" them by sending XSync requests on the X connection.
\fBpingInterval\fP specifies the time (in minutes) between each
ping attempt.  The default is 5 minutes.
.TP 8
.B "pingTimeout (\fPclass\fB PingTimeout)"
\fBpingTimeout\fP specifies the maximum amount of time (in
minutes) to wait for the terminal to respond to the XSync request.  If the
terminal does not respond, the connection is declared dead and \fIxwalld\fP
restarts.
The default is 5 minutes.
.TP 8
.B "raise (\fPclass\fB Raise)"
Specifies whether or not \fIxwalld\fP raises the window when a message arrives.
.\".in -1in
.SH WIDGETS
In order to specify resources, it is useful to know the hierarchy of
the widgets that compose \fIxwalld\fR.  In the notation below,
indentation indicates hierarchical structure.  The widget class name
is given first, followed by the widget instance name.
.sp
.nf
.TA .5i 1.0i 1.5i 2.0i
.ta .5i 1.0i 1.5i 2.0i
Xwall  xwall
	TopLevelShell  wall
		Form  form
			Label  title
			AsciiText  message
			Command  button
.fi
.sp
.SH FILES
/usr/lib/X11/app-defaults/Xwall - specifies required resources
.SH "SEE ALSO"
X(1), xwall(1), wall(1)
.SH COPYRIGHT
Copyright 1990 by University of Wisconsin-Madison
.SH AUTHOR
Tim Theisen
