
//
//    X SHARE MANAGER (XSM)
//
//    Copyright (C) 1995  David Simons
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//
// $Id: busy.h,v 2.2 1995/06/09 20:26:50 davidsi Exp $
//
// $Log: busy.h,v $
// Revision 2.2  1995/06/09  20:26:50  davidsi
// - Added GNU copyright message.
//
// Revision 2.1  1995/02/27  22:08:33  davidsi
// - Added percentcomplete member to the Busy class. This caches the previous
//   percentage value that was plotted.  This is used to save screen updates,
//   as an update only occurs when the percentage changes.
// - Added a BusyCompleted() member that also displays a label when updating
//   the completed bar.
//
// Revision 2.0  1995/02/05  18:38:25  davidsi
// - Initial version.
//
//
//
#ifndef __BUSY_H
#define __BUSY_H

#include "drawdialog.h"


// 
// The Busy class
//
class Busy 
{
	class Drawdialog *dd;
	double textheight;	// height of text written by BusyMessage
	int maxcount;
	int percentcomplete;	// % of work completed 
public:
	void BusyCompleted(int count,char *txt);
	void BusyCompleted(int count);
	void BusyMessage(char *txt);
	void BusyTotal(int count);
	Busy(); 
	virtual ~Busy(); 
};

#endif
