/* CHK=0xEF8D */
/*+-------------------------------------------------------------------------
	config.h - u386mon system monitor configuration

Hopefully, we will hide most of the Machiavellian version-hackery
--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:08-03-1993-15:50-wht@n4hgf-source control point x2.70 */
/*:07-15-1992-14:31-wht@n4hgf-2.60 release - u386mon+siotools merge */
/*:03-09-1992-11:54-wht@n4hgf-p_sid addition per rw@namu01.gwdg.de */
/*:08-20-1991-14:00-root@n4hgf-add ESIX per info from jdm1@esd1.esd.com */
/*:08-20-1991-12:44-root@n4hgf-nba@sysware.dk S5R31 and config reorg */
/*:08-01-1991-23:34-wht@n4hgf-release 2.40 source control point */
/*:08-10-1990-14:12-jmd@p1so/wht@n4hgf-2.20-add Tandem Integrity S2 */
/*:08-07-1990-14:24-wht@n4hgf-nba@sysware.dk SVR31 updates */
/*:08-02-1990-15:35-wht@n4hgf-2.12-old curses hacks+minor 3.2 formalizations */
/*:08-01-1990-19:24-jdc@dell.com-add DELL config */
/*:08-01-1990-12:24-wht@n4hgf-2.11-try to support ISC 1.x.x */
/*:07-28-1990-18:06-wht@n4hgf-2.10 release */
/*:07-26-1990-17:51-wht-creation */

#ifndef _config_h
#define _config_h

#define U386MON

#if defined(M_UNIX)
#define HAS_RDCHK
#define HAS_P_SID	     /* has proc->p_sid (job control) */
#define HAS_NAP
#define M_TERMINFO
#if !defined(SVR32)
#define SVR32
#endif
#if !defined(SCO320) && !defined(USIZE_FIXED)	/* you want USIZE_FIXED */
#define USIZE_FIXED	     /* unless you are using SCO 3.2.0 */
#endif
/* The next two lines may speed up other True S5R3 versions, but I can't say */
#define PERFORMANCE	     /* see u386mon.c, kludge.c,
			      * /usr/include/tinfo.h */
#define CURSES_MACROS
#endif

#if defined(DELL)
#define ISC
#if !defined(SVR32)
#define SVR32
#endif
#endif

/*
 * no offense to ESIX or ISC, but this is what works
 * see undef of NATIVE_PANELS below
 */
#if defined(ESIX532)
#define ISC
#define ISC22
#endif

#ifdef ISC_1
#define ISC
#if !defined(SVR31)
#define SVR31
#endif
#ifndef NO_ISTOUCH
#define NO_ISTOUCH
#endif
#else /* !ISC 1.x.x */
#if defined(ISC)
#define HAS_RDCHK
#define HAS_NAP
#if !defined(SVR32)
#define SVR32
#endif
#endif
#endif

#if defined(SVR32)
#define NATIVE_PANELS
#define HAS_BOOTINFO
#define HAS_TIMEB
#endif

/*
 * ESIX panels not existent or don't work (unclear, but this works)
 */
#if defined(ESIX532)
#undef NATIVE_PANELS
#endif

/*
 * some old curses do not have is_wintouched() or is_linetouched()
 * ... sigh ... This makes our homebrew panel object severely
 * disappointed, maybe useless ... but define NO_ISTOUCH to try
 * it if you get undefined externs for these two work saver functions.
 */
#ifdef SVR31
#ifndef NO_ISTOUCH
/* #define NO_ISTOUCH */
#endif
#endif

#ifdef MOTOROLA_SVR3
#ifndef NO_ISTOUCH
#define NO_ISTOUCH
#endif
#endif

#if defined(mips)
#if !defined(SVR31)
#define SVR31
#endif
#if !defined(NO_ISTOUCH)
#define NO_ISTOUCH
#endif
#endif

#define DPT_NONE	0
#define DPT_PS		1
#define DPT_PS_LONG	2
#define DPT_EXTRA	3
#if defined(M_UNIX) || defined(SIO_IS_FAS)
#define DPT_SIO		4
#endif
#if defined(M_UNIX) || defined(SVR31) || defined(ISC22)
#define DPT_STREAMS	5
#define DPT_TABLE	6
#endif
#ifdef SCO322
#define DPT_WD		7
#endif

#endif /* _config_h */

/* vi: set tabstop=4 shiftwidth=4: */
/* end of config.h */
