
//
//    X SHARE MANAGER (XSM)
//
//    Copyright (C) 1995  David Simons
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//
// $Id: database.h,v 2.2 1995/06/17 20:37:31 davidsi Exp $
//
// $Log: database.h,v $
// Revision 2.2  1995/06/17  20:37:31  davidsi
// - Added an alternative DatabaseInsert() that can operate with integer
//   values.
//
// Revision 2.1  1995/06/09  20:33:01  davidsi
// - Added GNU copyright message.
//
// Revision 2.0  1995/04/25  21:16:51  davidsi
// - Intial version.
//
//
//
#ifndef __DATABASE_H
#define __DATABASE_H

#include <stdio.h>
#include <string.h>

#include "slist.h"
#include "record.h"
#include "trans.h"
#include "div.h"
#include "price.h"
#include "button.h"
#include "optionl.h"
#include "semaphore.h"
#include "callback.h"


//
// The Database class
//
class Database : public slist {
protected:
	virtual int compare(list_node *,list_node *);
	virtual char *version();
	class Databaseitem *lastpos;
private:
	class Databaseitem *DatabaseSearch(char *,char *);
public:
	void DatabaseInsert(char *key,char *subkey,char *item);
	void DatabaseInsert(char *key,char *subkey,int item);
	void DatabaseInsert(char *key,char *subkey,double item);
	void DatabaseInsertmultiple(char *key,char *subkey,char *item);
	char *DatabaseRetrieve(char *key,char *subkey);
	char *DatabaseRetrievenext(char *key,char *subkey);
	void DatabaseRetrievereset();
	void DatabaseReplace(char *item);
	void DatabaseDelete(char *key,char *subkey);

	class Databaseitem *head() {
		return( LISTREMAP(Databaseitem,slist,head,this) );
	}

	Database(char *name);
	virtual ~Database();
	
};

#endif
