
//
//    X SHARE MANAGER (XSM)
//
//    Copyright (C) 1995  David Simons
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//
// $Id: date.h,v 2.3 1995/06/17 20:35:35 davidsi Exp $
// 
// $Log: date.h,v $
// Revision 2.3  1995/06/17  20:35:35  davidsi
// - Added sub() function member to the date class.
//
// Revision 2.2  1995/06/09  20:53:44  davidsi
// - Added GNU copyright message.
//
// Revision 2.1  1995/04/16  20:28:12  davidsi
// - Added sub() function member so days can be subtracted as well as added.
// - Added a setdate() function that assigns the date from one instance to
//   another.
//
// Revision 2.0  1995/01/19  21:32:08  davidsi
// - Initial version.
//
//
//

#ifndef __DATE_H
#define __DATE_H

class date {

	unsigned long timestamp;	// actual date 

private:
	int checkdate( int year,int month,int day);
	int julian2day( int year,int jday, int &month, int &day);
	int julianday( int year, int month,int day);
	int weekday( int year,int month,int day);
	int weeknr( int year,int month,int day);
	void scanmmddyy( char *date, int &year,int &month,int &day);
	void scanyyyymmdd( char *date, int &year, int &month,int &day);
	void scanddmmyy( char *date, int &year, int &month,int &day);
	int scanjulian( char *date, int &year, int &month,int &day);
	int scandate( char *date, int &year, int &month,int &day);
	int scanenglish( char *str,int &year, int &month, int &day );
	int days_in_month( int Year, int month);
#ifdef NEVER
	int day_number( int Year, int month, int Day);
	int time_to_year( unsigned long *time );
	char * month_name(int month);
#endif

public:
	int setdate(int dd,int mm,int yy);
	int setdate(char *string);
	int setdate();				// set todays date
	int setdate(class date &);

	char *getdate();			// return date string
	void getdate(int &dd,int &mm,int &yy);	// gets the date

	int inrange(class date *,class date *);	// TRUE when date between 2
	int datesubtract(class date *);		// no of days between dates
	int daysince1970();			// returns days since 1970
	void daysince1970(int day);		// sets days since 1970
	int days_in_month();			// days in current month
	void add(int days);			// add days to date
	void add(class date *);			// add date to date
	void sub(int days);			// subtract days from date
	void sub(class date *);			// subtract date from date
	int compare(class date *d2);		// compare with another date
	date();
	~date();
};

#endif
