/* CHK=0x88E9 */
/*+-------------------------------------------------------------------------
	det_stream.c - UNIX V/386 system monitor stream usage detail
	martin@hppcmart.grenoble.hp.com

00000000001111111111222222222233333333334444444444555555555566666666667777777777
01234567890123456789012345678901234567890123456789012345678901234567890123456789
Resource             Config Alloc Fail -- (% of resource used) -----------------
#################### ###### ##### #### #########################################
  Defined functions:

--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:06-30-1995-19:50-guym@sco.com-SCO open server 5 support added */
/*:08-03-1993-15:50-wht@n4hgf-source control point x2.70 */
/*:07-15-1992-14:31-wht@n4hgf-2.60 release - u386mon+siotools merge */
/*:08-20-1991-12:44-root@n4hgf-nba@sysware.dk S5R31 and config reorg */
/*:08-01-1991-23:34-wht@n4hgf-release 2.40 source control point */
/*:05-15-1991-17:22-wht@n4hgf-2.3 patches for SVR31 from nba@sysware.dk */
/*:02-07-1991-13:30-martin@hppcmart-creation */

#include "config.h"

#if defined(DPT_STREAMS)

#include <curses.h>
#include "libpanel.h"
#include <string.h>
#include <nlist.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/var.h>
#undef NGROUPS_MAX
#undef NULL
#include <sys/param.h>
#include <sys/stream.h>
#include <sys/strstat.h>

#include "nlsym.h"
#include "libkmem.h"
#include "libmem.h"
#include "libswap.h"
#include "libnlsym.h"
#include "u386mon.h"

extern struct var v;
unsigned stream_size[NCLASS + 4];
ushort rbsize[NCLASS];
struct strstat strst;

#define _NDX_STREAMS	0
#define _NDX_QUEUES		1
#define _NDX_MESSAGES	2
#define	_NDX_NBLK		3
#define _NDX_NBLK4		4
#define _NDX_NBLK16		5
#define _NDX_NBLK64		6
#define _NDX_NBLK128	7
#define _NDX_NBLK256	8
#define _NDX_NBLK512	9
#define _NDX_NBLK1024	10
#define _NDX_NBLK2048	11
#define _NDX_NBLK4096	12
#define _NDX_NBLK8192	13
#define _NDX_NBLK16k	14

/*+----------------------------------------------------------------------------
	init_stream()
-----------------------------------------------------------------------------*/
void
init_stream()
{
    int nmblock, i;

    kread((caddr_t) rbsize, rbsizeaddr, sizeof(ushort) * NCLASS);
    stream_size[_NDX_STREAMS] = v.v_nstream;
    stream_size[_NDX_QUEUES] = v.v_nqueue;
    kread((caddr_t) & nmblock, nmblockaddr, sizeof(int));

    stream_size[_NDX_MESSAGES] = nmblock;
    stream_size[_NDX_NBLK4] = v.v_nblk4;
    stream_size[_NDX_NBLK16] = v.v_nblk16;
    stream_size[_NDX_NBLK64] = v.v_nblk64;
    stream_size[_NDX_NBLK128] = v.v_nblk128;
    stream_size[_NDX_NBLK256] = v.v_nblk256;
    stream_size[_NDX_NBLK512] = v.v_nblk512;
    stream_size[_NDX_NBLK1024] = v.v_nblk1024;
    stream_size[_NDX_NBLK2048] = v.v_nblk2048;
    stream_size[_NDX_NBLK4096] = v.v_nblk4096;
    stream_size[_NDX_NBLK] = 0;
    for (i = _NDX_NBLK4; i <= _NDX_NBLK4096; i++)
	stream_size[_NDX_NBLK] += stream_size[i];
}

stream_size_update(unsigned *stream_size)
{
    struct pagestat pagest;
    int i,j;

    stream_size[_NDX_NBLK]=0;

    kread((caddr_t) &pagest, pagestaddr, sizeof(struct pagestat));
    for (i = _NDX_NBLK4, j=0; i <= _NDX_NBLK16k; i++, j++) {
	stream_size[i] = pagest.alc[j];
	stream_size[_NDX_NBLK] += stream_size[i];
    }

}
/*+----------------------------------------------------------------------------
	draw_streamscale_literals(win, y, x);

00000000001111111111222222222233333333334444444444555555555566666666667777777777
01234567890123456789012345678901234567890123456789012345678901234567890123456789
Resource             Config Alloc Fail -- (% of resource used) -----------------
Streams              ###### ##### #### #########################################
Queues
Message blocks
Data blocks
Data block size ####
-----------------------------------------------------------------------------*/

void
draw_streamscale_literals(win, y, x)
WINDOW *win;
int y, x;

{
    static char *header =
    "Resource            Config Alloc  Fail -- (% of resource used) ";
    int x2, i;

    wmove(win, y, x);
    use_cp(win, cpBANNER);
    waddstr(win, header);
    getyx(win, y, x2);
    while (x2++ <= COLS)
	waddch(win, (chtype) '-');
    use_cp(win, cpLIT);
    clear_area(win, getmaxy(win) - 1, 0, getmaxx(win));
    mvwaddstr(win, y + 1, x, "Streams");
    mvwaddstr(win, y + 2, x, "Queues");
    mvwaddstr(win, y + 3, x, "Message blocks");
    mvwaddstr(win, y + 4, x, "Data blocks");
    for (i = 0; i < NCLASS; i++)
	mvwprintw(win, (y + i + 5), x, "Data block size %4lu", rbsize[i]);
}

/*+----------------------------------------------------------------------------
	update_streamscale(win, y, x, width);

00000000001111111111222222222233333333334444444444555555555566666666667777777777
01234567890123456789012345678901234567890123456789012345678901234567890123456789
Conf  Alloc Fail  -- (% of resource used) -----------------
##### ##### ##### #########################################
-----------------------------------------------------------------------------*/
#define _STREAM_CO	0
#define _STREAM_AL	6
#define _STREAM_FA	12
#define _STREAM_SX	18

void
update_streamscale(win, y, x, width)
WINDOW *win;
int y, x;
int width;

{
    int percent_used, percent_max;
    int i, itmp, max;
    alcdat *strdat;

    kread((caddr_t) & strst, strstaddr, sizeof(struct strstat));

    strdat = (alcdat *) & strst;
#ifdef SCO325
    stream_size_update(stream_size);
#endif
    for (i = 0; i < NCLASS + 4; i++)
    {
	percent_used = stream_size[i] ? (strdat->use * 100 / stream_size[i]) : 0;
	percent_max = stream_size[i] ? (strdat->max * 100 / stream_size[i]) : 0;
	use_cp(win, cpINFO);
	mvwprintw(win, y + i, _STREAM_CO + x, "%5i", stream_size[i]);
	mvwprintw(win, y + i, _STREAM_AL + x, "%5i", strdat->use);
	if (strdat->fail)
	    use_cp(win, cpHIGH);
	else
	    use_cp(win, cpINFO);
	mvwprintw(win, y + i, _STREAM_FA + x, "%5i", strdat->fail);
	wmove(win, y + i, _STREAM_SX + x);

	if (percent_used < 70)
	    use_cp(win, cpLOW);
	else if (percent_used < 90)
	    use_cp(win, cpMED);
	else
	    use_cp(win, cpHIGH);

	itmp = (width * percent_used) / 100;
	max = (width * percent_max) / 100;
	while (-1)
	{
	    itmp--;
	    max--;
	    if (max < 1)
	    {
		use_cp(win, cpHIGH);
		waddch(win, (chtype) 'M');
		break;
	    }
	    if (itmp > -1)
		waddch(win, (chtype) '-');
	    else
		waddch(win, (chtype) ' ');
	}

	wclrtoeol(win);
	strdat++;
    }
}

#endif /* DPT_STREAMS */

/* vi: set tabstop=4 shiftwidth=4: */
/* end of det_stream.c */
