
//
//    X SHARE MANAGER (XSM)
//
//    Copyright (C) 1995  David Simons
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//
// $Id: dplot.h,v 2.3 1995/06/07 20:42:17 davidsi Exp $
//
// $Log: dplot.h,v $
// Revision 2.3  1995/06/07  20:42:17  davidsi
// - The dplot class now longer needs a Printer member.
// - Added GNU copyright message.
//
// Revision 2.2  1995/03/02  21:39:21  davidsi
// - The dplot class is now also derived from the menu class.
// - Added full printer support via the Printer class.
//
// Revision 2.1  1995/01/31  22:21:21  davidsi
// - Modified to reflect name changes in the Draw class.
//
// Revision 2.0  1995/01/19  22:02:37  davidsi
// - Revised to use the new date class.
//
// Revision 1.1  1994/12/11  20:48:02  davidsi
// Initial revision
//
//
//

#ifndef __DPLOT_H
#define __DPLOT_H

#include <stdio.h>
#include <string.h>

#include "security.h"
#include "draw.h"
#include "drawdialog.h"
#include "date.h"
#include "menu.h"




//
// This inheirits from the Drawdialog class so that resize callbacks
// can be handled.
//
class dplot : public Menu, private Drawdialog
{
	class date start_date;		// Start date for the valuation
	class date end_date;		// End date for the valuation
	unsigned long flags;	// see DPLOT_FLAGS_XXX

	security *sec;
        double *array;
        unsigned long number;
        Draw *dd;
        double min,max;
	Draw *outputdraw;		// the Draw instance for the printer

private:

	virtual void MenuCallback(unsigned long id,int flag);
        virtual void DrawdialogResize();
	static void exit(char *rthis);

public:
	void setsecurity(security *sec);
	void setoutput(Draw *drw);
	void plot();

	void ipriceplot();		// interactive price plot
	dplot();
	~dplot();

friend class Dplotprint;
friend class Summaryprint;
};


#endif
