
//
//    X SHARE MANAGER (XSM)
//
//    Copyright (C) 1995  David Simons
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//
// $Id: drawlj.h,v 2.1 1995/06/09 20:53:44 davidsi Exp $
//
// $Log: drawlj.h,v $
// Revision 2.1  1995/06/09  20:53:44  davidsi
// - Added GNU copyright message.
//
// Revision 2.0  1995/03/02  21:37:35  davidsi
// - Initial version.
//
//
//
#ifndef __DRAWLJ_H
#define __DRAWLJ_H

#include "draw.h"
#include "postscript.h"

class Drawlj : public Printerdraw {

private:
	unsigned long ljflags;	// see below LJFLAGS_XXX
	FILE *file;		// output file
	double pxbase;		// conversion for moving (0,0) on paper
	double pybase;

	class postscript ps;

	//
	// Font information
	//
	double fontsize;	// current size of font in points
	char *fontname;		// current font name
	double font_height;	// current font height in points
	char *current_font;	// current name of postscript font 

	char *tmpfilename;	// name of temporary file

private:
	//
	// These are the actual drawing functions for a dialog
	// based drawing.
	//
	virtual void drv_clearpage();
	virtual void drv_drawpage();
	virtual void drv_drawto(double x,double y);
	virtual void drv_moveto(double x,double y);
	virtual void drv_rect(double x1,double y1,double x2,double y2);
	virtual void drv_setfont(char *name,double fsize);
        virtual void drv_setgrey(int percentage);
        virtual void drv_setlinestyle(int count,double *len);
	virtual void drv_startpage();
	virtual void drv_text(char *string);
	virtual double drv_textlength(char *text);
	virtual double drv_textheight();
	virtual void drv_setlinewidth(double width);
	virtual void drv_setcolour(colour_e);
	//
	// This overides the inherited setup function.
	//
	virtual void PrinterdrawSetup();

public:
        Drawlj();
        ~Drawlj();
};

#define LJFLAGS_HPGLMODE	0x1

#endif
