
//
//    X SHARE MANAGER (XSM)
//
//    Copyright (C) 1995  David Simons
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//
// $Id: dsec.h,v 2.3 1995/06/07 20:43:22 davidsi Exp $
//
// $Log: dsec.h,v $
// Revision 2.3  1995/06/07  20:43:22  davidsi
// - Added support for specifying unit trusts.
//
// Revision 2.2  1995/05/18  20:58:51  davidsi
// - Callbacks are now stored using opaque handles rather than pointers to
//   the actual nodes (see callback.C for the whole story).
//
// Revision 2.1  1995/04/16  20:28:52  davidsi
// - Added callback_sec member to allow security displays to be updated when
//   securities are added, removed or modified.
//
// Revision 2.0  1995/04/03  20:45:44  davidsi
// - Initial version.
//
//
//
#ifndef __DSEC_H
#define __DSEC_H

#include <stdio.h>
#include <string.h>

#include "security.h"
#include "semaphore.h"
#include "callback.h"
#include "textdialog.h"

class Securitiesdisplay : public Textdialog {
	unsigned long optionflags;	// Options for display
	char setmenuflag;		// has menu/title been set
	Semaphore colourdialog;		// colour dialog display sem.
	Callbackid callback_sec;	// callback node for security changes
	//
private:
	virtual void MenuCallback(unsigned long code, int onflag);
	void create_display();
	static void redisplay(char *tmpthis,char *);
public:
	Securitiesdisplay();
	~Securitiesdisplay();
};

//
// Values for optionflags
//
#define DSEC_OPTION_SHARE	0x1
#define DSEC_OPTION_WARRANT	0x2
#define DSEC_OPTION_UNITTRUST	0x4
#define DSEC_OPTION_TRADED	0x8
#define DSEC_OPTION_NOTTRADED	0x10
#define DSEC_OPTION_AUTO	0x20
#define DSEC_OPTION_MANUAL	0x40

#endif
