
//
//    X SHARE MANAGER (XSM)
//
//    Copyright (C) 1995  David Simons
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//
// $Id: dslist.h,v 2.0 1995/06/09 20:57:36 davidsi Exp $
//
// $Log: dslist.h,v $
// Revision 2.0  1995/06/09  20:57:36  davidsi
// - Added GNU copyright message.
//
//
//
#ifndef __DSLIST_H
#define __DSLIST_H

#include <stdio.h>
#include <string.h>

#include "slist.h"


//
// dslist_head is the class that provides for the secondary head of 
// nodes that are on a stored list. 
//
class dslist_head {
	class dslist_node *first;	// first record on secondary list
public:
	dslist_head();
	~dslist_head();

	void dual_add(class dslist_node *);
	class dslist_node *dual_head();
};

//
// The main head of a double stored list is a normal stored list head
// 
class dslist : public slist {
};

//
// Nodes on a double stored list are the same as normal stored list nodes
// accept one can follow the pointer that defines the next node on the
// second list chained through the nodes
// 
class dslist_node : public slist_node {
	class dslist_node *next_node;	// next record on secondary list
	class dslist_node *last_node;	// last record on secondary list
public:
	friend class dslist_head;

	class dslist_node *dual_next();
	void dual_remove();
};


#endif
