/*+-------------------------------------------------------------------------
	ecutermio.h

 An attempt to mask the differences between posix termios and sysv termio.
 Daniel Harris.
--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:04-09-1995-03:10-wht@gyro-fix Solaris NCC et al redef warnings */
/*:05-04-1994-04:39-wht@n4hgf-ECU release 3.30 */
/*:01-23-1994-14:57-wht@n4hgf-fix type in #undef */
/*:01-16-1994-16:48-wht@n4hgf-organize after new ports */
/*:12-18-1993-??:??-daniel@reubio-transplanted into 3.28.06 */
/*:12-15-1993-??:??-daniel@reubio-moved NCC -> NCCS #define here from ecu.h */
/*:11-27-1993-??:??-daniel@reubio-created */

#ifndef _ecutermio_h
#define _ecutermio_h

#if defined(CFG_TermiosLineio)
#if defined(sun)
#include <termios.h>
#define termio termios
#if !defined (SVR4)			 /* SunOS 4.1.x */
#undef	NCC
#undef	TCSETA
#undef	TCSETAF
#undef	TCSETAW	
#define	NCC	NCCS
#define	TCSETA	TCSANOW
#define	TCSETAF	TCSAFLUSH
#define	TCSETAW	TCSADRAIN
#endif
#else /* SVR4 set for Solaris 2.x */
#include <sys/ioctl.h>
#include <termios.h>
#define	termio	termios

#undef 	NCC
#define	NCC	NCCS

#undef 	TCSETA
#define	TCSETA	TCSANOW

#undef 	TCSETAF
#define	TCSETAF	TCSAFLUSH

#undef 	TCSETAW
#define	TCSETAW	TCSADRAIN

#endif /* CFG_TermiosLineio */
#else /* use termio */
#include <termio.h>

/* ecutermio.c and it's callers need these  for termio base */

#if !defined(TCOFF)
#define	TCOOFF	0
#endif

#if !defined(TCOON)
#define	TCOON	1
#endif

#if !defined(TCIFLUSH)
#define	TCIFLUSH	0
#endif

#if !defined(TCOFLUSH)
#define	TCOFLUSH	1
#endif

#if !defined(TCIOFLUSH)
#define	TCIOFLUSH	2
#endif

#endif /* CFG_TermiosLineio */

#endif /* _ecutermio_h */

/* vi: set tabstop=4 shiftwidth=4: */
/* end of ecutermio.h */
