AFM=fonts/afm
BDF=fonts/bdf
FONTS=fonts/gsf
PFA=fonts/pfa
GSBDF=gs386
fonts: AvantGarde Bookman CharterBT Courier Cyrillic Helvetica \
	NewCenturySchlbk Palatino Symbol TimesRoman \
	Ugly Utopia ZapfChancery ZapfDingbats
FBEGIN=echogs -w _temp_ -n -x 5b28	# open bracket, open parenthesis
P2=-x 2928				# close and open parenthesis
FNEXT=echogs -a _temp_ -n
FLAST=echogs -a _temp_
FEND=-x 295d /ARGUMENTS exch def	# close parenthesis, close bracket
RUNBDF=$(GSBDF) -dNODISPLAY _temp_ bdftops.ps quit.ps


AvantGarde: $(FONTS)/pagk.gsf $(FONTS)/pagko.gsf $(FONTS)/pagd.gsf \
	$(FONTS)/pagdo.gsf

$(FONTS)/pagk.gsf: $(BDF)/avt18.bdf $(AFM)/av-k.afm
	$(FBEGIN) $(BDF)/avt18.bdf $(P2) $(AFM)/av-k.afm $(P2)
	$(FNEXT) $(FONTS)/pagk.gsf $(P2)
	$(FLAST) AvantGarde-Book $(P2) 4082000 $(FEND)
	$(RUNBDF)

$(FONTS)/pagko.gsf: $(BDF)/pagko.bdf $(AFM)/av-ko.afm
	$(FBEGIN) $(BDF)/pagko.bdf $(P2) $(AFM)/av-ko.afm $(P2)
	$(FNEXT) $(FONTS)/pagko.gsf $(P2)
	$(FLAST) AvantGarde-BookOblique $(P2) 4082200 $(FEND)
	$(RUNBDF)

$(FONTS)/pagd.gsf: $(BDF)/pagd.bdf $(AFM)/av-d.afm
	$(FBEGIN) $(BDF)/pagd.bdf $(P2) $(AFM)/av-d.afm $(P2)
	$(FNEXT) $(FONTS)/pagd.gsf $(P2)
	$(FLAST) AvantGarde-Demi $(P2) 4083000 $(FEND)
	$(RUNBDF)

$(FONTS)/pagdo.gsf: $(BDF)/pagdo.bdf $(AFM)/av-do.afm
	$(FBEGIN) $(BDF)/pagdo.bdf $(P2) $(AFM)/av-do.afm $(P2)
	$(FNEXT) $(FONTS)/pagdo.gsf $(P2)
	$(FLAST) AvantGarde-DemiOblique $(P2) 4083200 $(FEND)
	$(RUNBDF)


Bookman: $(FONTS)/pbkl.gsf $(FONTS)/pbkli.gsf $(FONTS)/pbkd.gsf \
	$(FONTS)/pbkdi.gsf

$(FONTS)/pbkl.gsf: $(BDF)/pbkl.bdf $(AFM)/book-l.afm
	$(FBEGIN) $(BDF)/pbkl.bdf $(P2) $(AFM)/book-l.afm $(P2)
	$(FNEXT) $(FONTS)/pbkl.gsf $(P2)
	$(FLAST) Bookman-Light $(P2) 4114000 $(FEND)
	$(RUNBDF)

$(FONTS)/pbkli.gsf: $(BDF)/pbkli.bdf $(AFM)/book-li.afm
	$(FBEGIN) $(BDF)/pbkli.bdf $(P2) $(AFM)/book-li.afm $(P2)
	$(FNEXT) $(FONTS)/pbkli.gsf $(P2)
	$(FLAST) Bookman-LightItalic $(P2) 4114100 $(FEND)
	$(RUNBDF)

$(FONTS)/pbkd.gsf: $(BDF)/pbkd.bdf $(AFM)/book-d.afm
	$(FBEGIN) $(BDF)/pbkd.bdf $(P2) $(AFM)/book-d.afm $(P2)
	$(FNEXT) $(FONTS)/pbkd.gsf $(P2)
	$(FLAST) Bookman-Demi $(P2) 4113000 $(FEND)
	$(RUNBDF)

$(FONTS)/pbkdi.gsf: $(BDF)/pbkdi.bdf $(AFM)/book-di.afm
	$(FBEGIN) $(BDF)/pbkdi.bdf $(P2) $(AFM)/book-di.afm $(P2)
	$(FNEXT) $(FONTS)/pbkdi.gsf $(P2)
	$(FLAST) Bookman-DemiItalic $(P2) 4113100 $(FEND)
	$(RUNBDF)



CharterBT: $(FONTS)/bchr.gsf $(FONTS)/bchri.gsf $(FONTS)/bchb.gsf \
	$(FONTS)/bchbi.gsf



		



Courier: $(FONTS)/ncrr.gsf $(FONTS)/ncrri.gsf $(FONTS)/ncrb.gsf \
	$(FONTS)/ncrbi.gsf







Cyrillic: $(FONTS)/cyr.gsf $(FONTS)/cyri.gsf


Helvetica: $(FONTS)/phvr.gsf $(FONTS)/phvro.gsf $(FONTS)/phvrrn.gsf \
	 $(FONTS)/phvb.gsf $(FONTS)/phvbo.gsf

$(FONTS)/phvr.gsf: $(BDF)/helvR24.bdf $(AFM)/helv.afm
	$(FBEGIN) $(BDF)/helvR24.bdf $(P2) $(AFM)/helv.afm $(P2)
	$(FNEXT) $(FONTS)/phvr.gsf $(P2)
	$(FLAST) Helvetica $(P2) 4030000 $(FEND)
	$(RUNBDF)

$(FONTS)/phvro.gsf: $(BDF)/helvO24.bdf $(AFM)/helv-o.afm
	$(FBEGIN) $(BDF)/helvO24.bdf $(P2) $(AFM)/helv-o.afm $(P2)
	$(FNEXT) $(FONTS)/phvro.gsf $(P2)
	$(FLAST) Helvetica-Oblique $(P2) 4030200 $(FEND)
	$(RUNBDF)

$(FONTS)/phvrrn.gsf: $(BDF)/hvmrc14.bdf $(AFM)/helv-n.afm
	$(FBEGIN) $(BDF)/hvmrc14.bdf $(P2) $(AFM)/helv-n.afm $(P2)
	$(FNEXT) $(FONTS)/phvrrn.gsf $(P2)
	$(FLAST) Helvetica-Narrow $(P2) 4030310 $(FEND)
	$(RUNBDF)

$(FONTS)/phvb.gsf: $(BDF)/helvB24.bdf $(AFM)/helv-b.afm
	$(FBEGIN) $(BDF)/helvB24.bdf $(P2) $(AFM)/helv-b.afm $(P2)
	$(FNEXT) $(FONTS)/phvb.gsf $(P2)
	$(FLAST) Helvetica-Bold $(P2) 4031000 $(FEND)
	$(RUNBDF)

$(FONTS)/phvbo.gsf: $(BDF)/helvBO24.bdf $(AFM)/helv-bo.afm
	$(FBEGIN) $(BDF)/helvBO24.bdf $(P2) $(AFM)/helv-bo.afm $(P2)
	$(FNEXT) $(FONTS)/phvbo.gsf $(P2)
	$(FLAST) Helvetica-BoldOblique $(P2) 4031200 $(FEND)
	$(RUNBDF)


NewCenturySchlbk: $(FONTS)/pncr.gsf $(FONTS)/pncrri.gsf $(FONTS)/pncb.gsf \
	$(FONTS)/pncbi.gsf

$(FONTS)/pncr.gsf: $(BDF)/ncenR24.bdf $(AFM)/ncs-r.afm
	$(FBEGIN) $(BDF)/ncenR24.bdf $(P2) $(AFM)/ncs-r.afm $(P2)
	$(FNEXT) $(FONTS)/pncr.gsf $(P2)
	$(FLAST) NewCenturySchlbk-Roman $(P2) 4040000 $(FEND)
	$(RUNBDF)

$(FONTS)/pncrri.gsf: $(BDF)/ncenI24.bdf $(AFM)/ncs-i.afm
	$(FBEGIN) $(BDF)/ncenI24.bdf $(P2) $(AFM)/ncs-i.afm $(P2)
	$(FNEXT) $(FONTS)/pncrri.gsf $(P2)
	$(FLAST) NewCenturySchlbk-Italic $(P2) 4040100 $(FEND)
	$(RUNBDF)

$(FONTS)/pncb.gsf: $(BDF)/ncenB24.bdf $(AFM)/ncs-b.afm
	$(FBEGIN) $(BDF)/ncenB24.bdf $(P2) $(AFM)/ncs-b.afm $(P2)
	$(FNEXT) $(FONTS)/pncb.gsf $(P2)
	$(FLAST) NewCenturySchlbk-Bold $(P2) 4041000 $(FEND)
	$(RUNBDF)

$(FONTS)/pncbi.gsf: $(BDF)/ncenBI24.bdf $(AFM)/ncs-bi.afm
	$(FBEGIN) $(BDF)/ncenBI24.bdf $(P2) $(AFM)/ncs-bi.afm $(P2)
	$(FNEXT) $(FONTS)/pncbi.gsf $(P2)
	$(FLAST) NewCenturySchlbk-BoldItalic $(P2) 4041100 $(FEND)
	$(RUNBDF)


Palatino: $(FONTS)/pplr.gsf $(FONTS)/pplri.gsf $(FONTS)/pplb.gsf \
	$(FONTS)/pplbi.gsf

$(FONTS)/pplr.gsf: $(BDF)/pal18.bdf $(AFM)/pal-r.afm
	$(FBEGIN) $(BDF)/pal18.bdf $(P2) $(AFM)/pal-r.afm $(P2)
	$(FNEXT) $(FONTS)/pplr.gsf $(P2)
	$(FLAST) Palatino-Roman $(P2) 4090000 $(FEND)
	$(RUNBDF)

$(FONTS)/pplri.gsf: $(BDF)/pplri.bdf $(AFM)/pal-i.afm
	$(FBEGIN) $(BDF)/pplri.bdf $(P2) $(AFM)/pal-i.afm $(P2)
	$(FNEXT) $(FONTS)/pplri.gsf $(P2)
	$(FLAST) Palatino-Italic $(P2) 4090100 $(FEND)
	$(RUNBDF)

$(FONTS)/pplb.gsf: $(BDF)/pplb.bdf $(AFM)/pal-b.afm
	$(FBEGIN) $(BDF)/pplb.bdf $(P2) $(AFM)/pal-b.afm $(P2)
	$(FNEXT) $(FONTS)/pplb.gsf $(P2)
	$(FLAST) Palatino-Bold $(P2) 4091000 $(FEND)
	$(RUNBDF)

$(FONTS)/pplbi.gsf: $(BDF)/pplbi.bdf $(AFM)/pal-bi.afm
	$(FBEGIN) $(BDF)/pplbi.bdf $(P2) $(AFM)/pal-bi.afm $(P2)
	$(FNEXT) $(FONTS)/pplbi.gsf $(P2)
	$(FLAST) Palatino-BoldItalic $(P2) 4091100 $(FEND)
	$(RUNBDF)


Symbol: $(FONTS)/psyr.gsf

$(FONTS)/psyr.gsf: $(BDF)/symb24.bdf $(AFM)/symbol.afm
	$(FBEGIN) $(BDF)/symb24.bdf $(P2) $(AFM)/symbol.afm $(P2)
	$(FNEXT) $(FONTS)/psyr.gsf $(P2)
	$(FLAST) Symbol 4050000 $(P2) SymbolEncoding $(FEND)
	$(RUNBDF)


TimesRoman: $(FONTS)/ptmr.gsf $(FONTS)/ptmri.gsf $(FONTS)/ptmb.gsf \
	$(FONTS)/ptmbi.gsf

$(FONTS)/ptmr.gsf: $(BDF)/timR24.bdf $(AFM)/times-r.afm
	$(FBEGIN) $(BDF)/timR24.bdf $(P2) $(AFM)/times-r.afm $(P2)
	$(FNEXT) $(FONTS)/ptmr.gsf $(P2)
	$(FLAST) Times-Roman $(P2) 4060000 $(FEND)
	$(RUNBDF)

$(FONTS)/ptmri.gsf: $(BDF)/timI24.bdf $(AFM)/times-i.afm
	$(FBEGIN) $(BDF)/timI24.bdf $(P2) $(AFM)/times-i.afm $(P2)
	$(FNEXT) $(FONTS)/ptmri.gsf $(P2)
	$(FLAST) Times-Italic $(P2) 4060100 $(FEND)
	$(RUNBDF)

$(FONTS)/ptmb.gsf: $(BDF)/timB24.bdf $(AFM)/times-b.afm
	$(FBEGIN) $(BDF)/timB24.bdf $(P2) $(AFM)/times-b.afm $(P2)
	$(FNEXT) $(FONTS)/ptmb.gsf $(P2)
	$(FLAST) Times-Bold $(P2) 4061000 $(FEND)
	$(RUNBDF)

$(FONTS)/ptmbi.gsf: $(BDF)/timBI24.bdf $(AFM)/times-bi.afm
	$(FBEGIN) $(BDF)/timBI24.bdf $(P2) $(AFM)/times-bi.afm $(P2)
	$(FNEXT) $(FONTS)/ptmbi.gsf $(P2)
	$(FLAST) Times-BoldItalic $(P2) 4061100 $(FEND)
	$(RUNBDF)



Ugly: uglyr.gsf

uglyr.gsf: ugly10.bdf
	$(FBEGIN) ugly10.bdf $(P2) uglyr.gsf $(P2)
	$(FLAST) Ugly $(P2) 4000000 $(FEND)
	$(RUNBDF)


Utopia: $(FONTS)/putr.gsf $(FONTS)/putri.gsf $(FONTS)/putb.gsf \
	$(FONTS)/putbi.gsf


ZapfChancery: $(FONTS)/zcr.gsf $(FONTS)/zcro.gsf $(FONTS)/zcb.gsf

$(FONTS)/zcr.gsf: $(BDF)/zcr24.bdf $(AFM)/zc-r.afm
	$(FBEGIN) $(BDF)/zcr24.bdf $(P2) $(AFM)/zc-r.afm $(P2)
	$(FNEXT) $(FONTS)/zcr.gsf $(P2)
	$(FLAST) ZapfChancery $(P2) 4070000 $(FEND)
	$(RUNBDF)

$(FONTS)/zcro.gsf: $(BDF)/zcro24.bdf $(AFM)/zc-mi.afm
	$(FBEGIN) $(BDF)/zcro24.bdf $(P2) $(AFM)/zc-mi.afm $(P2)
	$(FNEXT) $(FONTS)/zcro.gsf $(P2)
	$(FLAST) ZapfChancery-Oblique $(P2) 4070200 $(FEND)
	$(RUNBDF)

$(FONTS)/zcb.gsf: $(BDF)/zcb30.bdf $(AFM)/zc-b.afm
	$(FBEGIN) $(BDF)/zcb30.bdf $(P2) $(AFM)/zc-b.afm $(P2)
	$(FNEXT) $(FONTS)/zcb.gsf $(P2)
	$(FLAST) ZapfChancery-Bold $(P2) 4071000 $(FEND)
	$(RUNBDF)


ZapfDingbats: $(FONTS)/pzdr.gsf

$(FONTS)/pzdr.gsf: $(BDF)/pzdr.bdf $(AFM)/zd.afm
	$(FBEGIN) $(BDF)/pzdr.bdf $(P2) $(AFM)/zd.afm $(P2)
	$(FNEXT) $(FONTS)/pzdr.gsf $(P2)
	$(FLAST) ZapfDingbats $(P2) 4100000 $(FEND)
	$(RUNBDF)
