
//
//    X SHARE MANAGER (XSM)
//
//    Copyright (C) 1995  David Simons
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//
// $Id: localmacros.h,v 2.3 1995/06/09 20:53:44 davidsi Exp $
// 
// $Log: localmacros.h,v $
// Revision 2.3  1995/06/09  20:53:44  davidsi
// - Added GNU copyright message.
//
// Revision 2.2  1995/05/29  19:09:49  davidsi
// - Added VERY_SMALL_NUMBER define. Any value set to VERY_SMALL_NUMBER is
//   guaranteed to be smaller than SMALL_NUMBER.
//
// Revision 2.1  1995/03/02  21:05:35  davidsi
// - Added local_va_start2 macro that allows var args starting with
//   a named argument.
//
// Revision 2.0  1995/02/20  22:44:39  davidsi
// - Removed the MENUBUILD macro which was cumbersome and awkward to work with.
//   A new (simpler!) MENU macro replaces it.
//
// Revision 1.2  1994/11/05  21:12:02  davidsi
// - Various modifications to allow this file to compile using g++.
//
// Revision 1.1  1994/08/06  16:44:30  davidsi
// Initial revision
//
// 
// 
// 

#ifndef __LOCALMAC_H
#define __LOCALMAC_H

#define numeric(c)              ((c) >= '0' && (c) <= '9')
#define max(a,b)                ((a)<(b) ? (b) : (a))
#define min(a,b)                ((a)>(b) ? (b) : (a))
#define abs(x)                  ((x)>=0 ? (x) : -(x))

//
// VERY_SMALL_NUMBER must be smaller than SMALL_NUMBER
//
#define SMALL_NUMBER      (0.0000001)
#define VERY_SMALL_NUMBER (0.00000001)

//
// The below macro is used to cast the list_node's next() function
// to any class that has inheritated the next() function from
// the list_node class. This saves uncessary casts!
//
#define LISTREMAP(classname,actualclass,function,ptr)	\
	 ( (class classname *)( ((class actualclass *)ptr)->function() ))

//
// Creates a menu item (action items only) 
//
// This macro assume mb points to the appropriate menu_bar class member.
//
#define MENU(bname,iname,func,id)					\
	{								\
	class menu_item *ma=new class menu_item(mb,bname,iname,func,id);\
	}								\

#define local_va_dcl va_list va_alist
#define local_va_start(list) list = (char *) &va_alist;
#define local_va_start2(list,var) list = (char *) &(var);

#endif
