/* CHK=0x88A7 */
/*+-------------------------------------------------------------------------
	nlsym.h -- utility nlist - fast access to kernel /dev/kmem offsets
	wht@n4hgf.Mt-Park.GA.US

The nlsym file contains three records:
1.  struct stat unixstat - stat buffer from /unix at file creation time
2.  struct nlist nlsym - the structure of nlist'd information
3.  long unique - a unique identifier to help ensure correct nlsym length

--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:08-03-1993-15:50-wht@n4hgf-source control point x2.70 */
/*:07-15-1992-14:32-wht@n4hgf-2.60 release - u386mon+siotools merge */
/*:08-20-1991-12:44-root@n4hgf-nba@sysware.dk S5R31 and config reorg */
/*:08-14-1991-13:04-wht@n4hgf-STREAMS and table works for ISC 2.2 */
/*:08-01-1991-23:34-wht@n4hgf-release 2.40 source control point */
/*:05-15-1991-17:22-wht@n4hgf-2.3 patches for SVR31 from nba@sysware.dk */
/*:04-16-1991-02:25-martin@hppcmart additions for SCO 3.2.2 */
/*:08-10-1990-14:12-jmd@p1so/wht@n4hgf-2.20-add Tandem Integrity S2 */
/*:08-07-1990-14:24-wht@n4hgf-nba@sysware.dk SVR31 updates */
/*:08-02-1990-15:36-wht@n4hgf-2.12-old curses hacks+minor 3.2 formalizations */
/*:07-28-1990-18:06-wht@n4hgf-2.10 release */
/*:06-27-1990-01:57-wht@n4hgf-1.10-incorporate suggestions from alpha testers */
/*:06-27-1990-01:55-wht@n4hgf-use 64 bits of unique check */
/*:06-25-1990-04:14-wht@n4hgf-1.02-better error handling */
/*:06-24-1990-20:53-wht@n4hgf-v1.01-add ISC support thanks to peter@radig.de */
/*:06-21-1990-14:26-r@n4hgf-version x0.12 seems bug free */
/*:10-27-1988-11:07-wht-creation */

#ifndef _nlsym_h
#define _nlsym_h

#define UNIX_KERNEL		"/unix"
#define UNIX_NLSYM		"/unix.nlsym"
#define NLSYM_UNIQUE1	0x1BADD00DL
#define NLSYM_UNIQUE2	0xDEADB1FFL

#define Nindex_AVAILRMEM            0
#define Nindex_AVAILSMEM            1
#define Nindex_BDEVCNT              2
#define Nindex_BDEVSW               3
#if defined(HAS_BOOTINFO)
#define Nindex_BOOTINFO             4
#endif
#define Nindex_CDEVCNT              5
#define Nindex_CDEVSW               6
#define Nindex_CFREE                7
#define Nindex_CFREECNT             8
#define Nindex_CFREELIST            9
#if defined(M_UNIX)
#define Nindex_CONSSW              10
#endif
#define Nindex_CURPROC             11
#define Nindex_DINFO               12
#if defined(M_UNIX)
#define Nindex_DSTFLAG             13
#endif
#define Nindex_DUMPDEV             14
#if defined(M_UNIX)
#define Nindex_EMAP                15
#endif
#define Nindex_FFREELIST           16
#define Nindex_FILE                17
#define Nindex_FMODCNT             18
#define Nindex_FMODSW              19
#define Nindex_FREEMEM             20
#define Nindex_FSINFO              21
#define Nindex_FSTYPSW             22
#if defined(M_UNIX)
#define Nindex_HZ                  23
#endif
#define Nindex_IDLESERVER          24
#define Nindex_IFREELIST           25
#define Nindex_INODE               26
#define Nindex_KPTBL               27
#define Nindex_LBOLT               28
#define Nindex_LINECNT             29
#define Nindex_LINESW              30
#define Nindex_MAXCLICK            31
#define Nindex_MAXMEM              32
#define Nindex_MINFO               33
#define Nindex_MOUNT               34
#define Nindex_MSGLISTCNT          35
#define Nindex_NFSTYP              36
#define Nindex_NPTALLOCED          37
#define Nindex_NPTFREE             38
#define Nindex_NSERVERS            39
#define Nindex_NSWAP               40
#if defined(M_UNIX)
#define Nindex_NSYSENT             41
#define Nindex_OLDPROC             42
#define Nindex_OLD_CURPROC         43
#endif
#define Nindex_PANICSTR            44
#define Nindex_PHYSMEM             45
#define Nindex_PIPEDEV             46
#define Nindex_PROC                47
#define Nindex_RCINFO              48
#define Nindex_ROOTDEV             49
#define Nindex_RUNQ                50
#define Nindex_SHLBINFO            51
#define Nindex_SWAPDEV             52
#define Nindex_SWPLO               53
#define Nindex_SYSERR              54
#define Nindex_SYSINFO             55
#define Nindex_SYSSEGS             56
#define Nindex_SYSWAIT             57
#define Nindex_TIME                58
#if defined(M_UNIX)
#define Nindex_TIMEZONE            59
#endif
#define Nindex_TTHIWAT             60
#define Nindex_TTLOWAT             61
#define Nindex_TUNE                62
#define Nindex_U                   63
#if defined(M_UNIX)
#define Nindex_USERTABLE           64
#endif
#define Nindex_V                   65
#if defined(M_UNIX)
#define Nindex_WIN_UBLK            66
#endif
#define Nindex_REGION              67
#if defined(DPT_SIO)
#define Nindex_SIO_TTY             68
#endif
#if defined(DPT_STREAMS)
#define Nindex_STRST               69
#define Nindex_RBSIZE              70
#define Nindex_NMBLOCK             71
#define Nindex_PAGEST             72
#define Nindex_FLCKINFO            73
#define Nindex_RACTIVE             74

#endif
#if defined(DPT_TABLE)
#define Nindex_CALLOUT             75
#define Nindex_NUMCALLOUT          76
#define Nindex_NUMFREECALLOUT      77
#define Nindex_INODEFREECOUNT	   78
#define Nindex_FILEFREECOUNT	   79
#define Nindex_REGIONFREECOUNT	   80
#endif
#if defined(DPT_WD)
#define Nindex_FLSTATS             81
#define Nindex_WD1010STATS         82
#endif

#if defined(HAS_BOOTINFO)
#define bootinfoaddr (nlsym[Nindex_BOOTINFO].n_value)
#endif
#define freememaddr (nlsym[Nindex_FREEMEM].n_value)
#define lboltaddr (nlsym[Nindex_LBOLT].n_value)
#define maxmemaddr (nlsym[Nindex_MAXMEM].n_value)
#define minfoaddr (nlsym[Nindex_MINFO].n_value)
#define nswapaddr (nlsym[Nindex_NSWAP].n_value)
#define physmemaddr (nlsym[Nindex_PHYSMEM].n_value)
#define procaddr (nlsym[Nindex_PROC].n_value)
#define regionaddr (nlsym[Nindex_REGION].n_value)
#define sysinfoaddr (nlsym[Nindex_SYSINFO].n_value)
#define tuneaddr (nlsym[Nindex_TUNE].n_value)
#define vaddr (nlsym[Nindex_V].n_value)
#if defined(DPT_SIO)
#define sio_ttyaddr (nlsym[Nindex_SIO_TTY].n_value)
#endif /* DPT_SIO */
#if defined(DPT_STREAMS)
#define strstaddr (nlsym[Nindex_STRST].n_value)
#define rbsizeaddr (nlsym[Nindex_RBSIZE].n_value)
#define nmblockaddr (nlsym[Nindex_NMBLOCK].n_value)
#define pagestaddr (nlsym[Nindex_PAGEST].n_value)
#endif /* DPT_STREAMS */
#if defined(DPT_TABLE)
#define flckinfoaddr (nlsym[Nindex_FLCKINFO].n_value)
#define fileaddr (nlsym[Nindex_FILE].n_value)
#define ifreelistaddr (nlsym[Nindex_IFREELIST].n_value)
#define inodeaddr (nlsym[Nindex_INODE].n_value)
#define ffreelistaddr (nlsym[Nindex_FFREELIST].n_value)
#define ractiveaddr (nlsym[Nindex_RACTIVE].n_value)
#define cfreecntaddr (nlsym[Nindex_CFREECNT].n_value)
#define Dalloutaddr (nlsym[Nindex_CALLOUT].n_value)
#define numcalloutaddr (nlsym[Nindex_NUMCALLOUT].n_value)
#define numfreecalloutaddr (nlsym[Nindex_NUMFREECALLOUT].n_value)
#define inodefreecountaddr (nlsym[Nindex_INODEFREECOUNT].n_value)
#define filefreecountaddr (nlsym[Nindex_FILEFREECOUNT].n_value)
#define regionfreecountaddr (nlsym[Nindex_REGIONFREECOUNT].n_value)
#define syserraddr (nlsym[Nindex_SYSERR].n_value)
#endif /* DPT_TABLE */
#if defined(DPT_WD)
#define flstatsaddr (nlsym[Nindex_FLSTATS].n_value)
#define wd1010statsaddr (nlsym[Nindex_WD1010STATS].n_value)
#endif /* DPT_WD */

#ifdef DEFINE_NLSYM
struct nlist nlsym[] =
{
    {"availrmem"},
    {"availsmem"},
    {"bdevcnt"},
    {"bdevsw"},
#if defined(HAS_BOOTINFO)
    {"bootinfo"},
#else
    {"dummy"},
#endif
    {"cdevcnt"},
    {"cdevsw"},
    {"cfree"},
    {"cfreecnt"},
    {"cfreelist"},
#if defined(M_UNIX)
    {"conssw"},
#else
    {"dummy"},
#endif
    {"curproc"},
    {"dinfo"},
#if defined(M_UNIX)
    {"Dstflag"},
#else
    {"dummy"},
#endif
    {"dumpdev"},
#if defined(M_UNIX)
    {"emap"},
#else
    {"dummy"},
#endif
    {"ffreelist"},
    {"file"},
    {"fmodcnt"},
    {"fmodsw"},
    {"freemem"},
    {"fsinfo"},
    {"fstypsw"},
#if defined(M_UNIX)
    {"Hz"},
#else
    {"dummy"},
#endif
    {"idleserver"},
    {"ifreelist"},
    {"inode"},
    {"kptbl"},
    {"lbolt"},
    {"linecnt"},
    {"linesw"},
    {"maxclick"},
    {"maxmem"},
    {"minfo"},	/* MANDATORY */
    {"mount"},
    {"msglistcnt"},
    {"nfstyp"},
    {"nptalloced"},
    {"nptfree"},
    {"nservers"},
    {"nswap"},
#if defined(M_UNIX)
    {"nsysent"},
    {"oldproc"},
    {"old_curproc"},
#else
    {"dummy"},
    {"dummy"},
    {"dummy"},
#endif
    {"panicstr"},
    {"physmem"},
    {"dummy"},
    {"proc"},
    {"rcinfo"},
    {"rootdev"},
#if defined(MOTOROLA_SVR3)
    {"dummy"},
#else
    {"runq"},
#endif
    {"shlbinfo"},
    {"swapdev"},
    {"swplo"},
    {"syserr"},
    {"sysinfo"},	/* MANDATORY */
#if defined(MOTOROLA_SVR3)
    {"dummy"},
#else
    {"syssegs"},
#endif
    {"syswait"},
    {"time"},
#if defined(M_UNIX)
    {"Timezone"},
#else
    {"dummy"},
#endif
    {"tthiwat"},
    {"ttlowat"},
    {"tune"},
    {"u"},
#if defined(M_UNIX)
    {"usertable"},
#else
    {"dummy"},
#endif
    {"v"},
#if defined(M_UNIX)
    {"win_ublk"},
#else
    {"dummy"},
#endif
    {"region"},
#if defined(DPT_SIO)
#if defined(SIO_IS_FAS)
    {"fas_tty"},
#else
    {"sio_tty"},
#endif
#else
    {"dummy"},
#endif
#if defined(DPT_STREAMS)
    {"strst"},
    {"rbsize"},
    {"nmblock"},
    {"pagest"},
#else
    {"dummy"},
    {"dummy"},
    {"dummy"},
    {"dummy"},
#endif
#if defined(DPT_TABLE)
    {"flckinfo"},
    {"ractive"},
    {"callout"},
    {"num_callouts"},
    {"num_free_callouts"},
    {"ifreecnt"},
    {"filecnt"},
    {"regcnt"},
#else
    {"dummy"},
    {"dummy"},
    {"dummy"},
    {"dummy"},
    {"dummy"},
    {"dummy"},
    {"dummy"},
#endif
#if defined(DPT_WD)
    {"flstats"},
    {"wd1010stats"},
#else
    {"dummy"},
    {"dummy"},
#endif
    {(char *)0}
};

#else
extern struct nlist nlsym[];

#endif

#endif /* _nlsym_h */

/* vi: set tabstop=4 shiftwidth=4: */
/* end of nlsym.h */
