
//
//    X SHARE MANAGER (XSM)
//
//    Copyright (C) 1995  David Simons
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//
// $Id: optionl.h,v 2.1 1995/06/24 15:06:13 davidsi Exp $
//
// $Log: optionl.h,v $
// Revision 2.1  1995/06/24  15:06:13  davidsi
// - Added GNU copyright message.
//
// Revision 2.0  1995/03/02  21:35:52  davidsi
// - Initial version.
//
//
//
#ifndef __OPTIONL_H
#define __OPTIONL_H

#include "suplib.h"
#include "dialog.h"
#include "list.h"

//
// The Optionlistinstance represents one instance of an optionlist
// within a Optionlist class.
//
class Optionlistinstance : public list_node
{
	dialog d_list;
	class Optionlist *faddr;
	unsigned long cbvalue;
public:
	void OptionlistinstanceSet(char *listitem);
	char *OptionlistinstanceGet();
	void OptionlistinstanceRevise(char **newlist);
	char **OptionlistinstanceGetlist(int &count);
	void OptionlistinstanceDestroy();


	Optionlistinstance( class Optionlist *faddr , unsigned long);
	virtual ~Optionlistinstance();

friend class Optionlist;
};

//
// Newoptionlist specifies the type of optionlist to create
//
typedef struct Newoptionlist {
        int width;			// width in characters
        int height;			// height in visible items
        char **listitem;		// items to display
        char *listname;			// name of items in list
        char *selname;			// name for selection box
        int flags;			// see OLIST_FLAGS_XXXX
	char *font;			// font (can be NULL)
} Newoptionlist ;

#define OLIST_FLAGS_SEARCH		0x1	// auto search on text entry
#define OLIST_FLAGS_NOLABEL		0x2	// don't label the list
#define OLIST_FLAGS_AUTOP		0x4	// auto pick on text entry
#define OLIST_FLAGS_NOTEXT		0x8	// don't show text entry box

// 
// The Optionlist class
//
class Optionlist 
{
private:
	class list *callbacks;			// all attached callbacks
	static void mainlist(dialog,char *);	// real callback function
	virtual void OptionlistCallback(unsigned long id); 

public:
	Optionlistinstance *OptionlistCreate(Dialog &,
						Newoptionlist &,
						unsigned long id);

	Optionlist(); 
	virtual ~Optionlist(); 
};

#endif
