
//
//    X SHARE MANAGER (XSM)
//
//    Copyright (C) 1995  David Simons
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//
// $Id: paper.h,v 2.2 1995/06/24 15:06:13 davidsi Exp $
//
// $Log: paper.h,v $
// Revision 2.2  1995/06/24  15:06:13  davidsi
// - Added GNU copyright message.
//
// Revision 2.1  1995/06/17  20:32:25  davidsi
// - Added cm and further inch conversion macros.
//
// Revision 2.0  1995/01/31  22:27:50  davidsi
// - First version.
//
//
//
#ifndef __PAPER_H
#define __PAPER_H

//
// A4 paper sizes in inches
//
#define A4_PAPER_HEIGHT    11.64
#define A4_PAPER_WIDTH     8.27

//
// Number of points in an inch/cm
//
#define POINTSPERINCH	72.0
#define POINTSPERCM	(72.0/2.54)

//
// Maps inches/cm into points
//
#define INCHES2POINTS(x)	((x)*POINTSPERINCH)
#define CM2POINTS(x)		((x)*POINTSPERCM)

//
// Maps points to inches/cm
//
#define POINTS2INCHES(x)	((x)/POINTSPERINCH)
#define POINTS2CM(x)		((x)/POINTSPERCM)



#endif
