
//
//    X SHARE MANAGER (XSM)
//
//    Copyright (C) 1995  David Simons
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//
// $Id: postscript.h,v 2.3 1995/06/24 15:06:13 davidsi Exp $
//
// $Log: postscript.h,v $
// Revision 2.3  1995/06/24  15:06:13  davidsi
// - Added GNU copyright message.
//
// Revision 2.2  1995/03/02  20:59:39  davidsi
// - Switched pointsize to a double from an int.
//
// Revision 2.1  1995/01/31  22:18:58  davidsi
// - BUG FIX.  Did not protect against multiple inclusion.
//
// Revision 2.0  1995/01/19  21:42:45  davidsi
// - Initial version
//
//
//
#ifndef __POSTSCRIPT_H
#define __POSTSCRIPT_H

class font {


public:
	virtual double textwidth(char *text);
	virtual int set(char *name,int size);
	font();
	virtual ~font();
};


struct metrics {
  int up;
  int down;
  int left;
  int right;
};


class postscript: font {
private:
	double 		pointsize;	// points scaled by factor of 10
	struct metrics	*size_table;	// metrics of sized fonts
	char		*lig_table;	// ligatures
	char		*font_table;	// record of sized fonts
	unsigned short	*kern_table;	// first kerning chars
	char		*kern_chars;	// second kerning chars
	unsigned char	*kern_value;	// points into kern_lengths
	int		*kern_sizes;	// sizes of kernings

	//
	// These are only valid during a font load
	//
	char		*filename;	// filename
	FILE *fp;			// fileptr

	void freeresources();
public:
	virtual double textwidth(char *text);
	virtual int set(char *name,int size);
	postscript();
	virtual ~postscript();
};
#endif
