
//
//    X SHARE MANAGER (XSM)
//
//    Copyright (C) 1995  David Simons
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//
// $Id: prefs.h,v 2.2 1995/06/07 20:46:34 davidsi Exp $
//
// $Log: prefs.h,v $
// Revision 2.2  1995/06/07  20:46:34  davidsi
// - Moved VAR_PRICEPATH to this file.
// - New define (PREFS_DB_ENTRY) for preferences database.
//
// Revision 2.1  1995/05/18  20:59:38  davidsi
// - Added support for defaults held in the file /etc/defaults/xsm.  This
//   gives system wide information (set by the administrator) rather than
//   user specific preferences.
//
// Revision 2.0  1995/04/25  21:28:44  davidsi
// - Initial version.
//
//
#ifndef __PREFS_H
#define __PREFS_H

#include "database.h"


//
// This is used as the primary key for defaults in the preferences
// database.
//
#define PREFS_DB_ENTRY "Defaults"

#define VAR_PRICEPATH	"xsmprices"	// variable (env or default) for
					// path containing price files

class DatabasePrefs : public Database 
{
public:
	int DatabasePrefsAssignread(char *,char *,char *,char *);
	void DatabasePrefsAssign(char *key,char *skey,char *lhs,char *rhs);
	DatabasePrefs(char *);
	virtual ~DatabasePrefs();
};


//
//
//
class Defaultlist : public slist {
public:
	class Defaultnode *head() {
		return( LISTREMAP(Defaultnode,list,head,this) );
	}
	Defaultlist();
	virtual ~Defaultlist();
};

class Defaultnode : public slist_node {
	char *lhs;
	char *rhs;

	
public:
	class Defaultnode *next() {
		return( LISTREMAP(Defaultnode,list_node,next,this) );
	}
	char *DefaultnodeMatch(char *);
	void DefaultnodeLoad(class record *);
	Defaultnode();
	virtual ~Defaultnode();
};


//
//
//
extern class DatabasePrefs *db_prefs;

//
// Publicly available functions
//
extern char *Getdefault(char *);

#endif
