
//
//    X SHARE MANAGER (XSM)
//
//    Copyright (C) 1995  David Simons
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//
// $Id: setdate.h,v 2.4 1995/06/24 15:06:13 davidsi Exp $
//
// $Log: setdate.h,v $
// Revision 2.4  1995/06/24  15:06:13  davidsi
// - Added GNU copyright message.
//
// Revision 2.3  1995/06/17  20:34:22  davidsi
// - To allow checks to be made on date ranges, the inheritance from the
//   Date class must be public and not private.
//
// Revision 2.2  1995/04/16  20:26:33  davidsi
// - SetdateMonthyear() now requires a function that uses pointers to instances
//   of the date class.  The callback member has also been changed to handle this.
// - Added SetdateDaymonthyear() to allow days to also be set.
// - Added Display() function member.
// - Added a new constructor function that allows the date to be
//   initialized to a given date.
// - Inherit from the date class to make date manipulations simpler.
// - Added a mechanism for tayloring the title of the dialog.  The title
//   can be set with SetdateSettitle() and is held in the title member.
//
// Revision 2.1  1995/03/02  21:06:24  davidsi
// - Removed all dialog references - now uses the Dialog class.
//
// Revision 2.0  1995/02/05  18:43:09  davidsi
// - Initial version.
//
//
#ifndef __SETDATE_H
#define __SETDATE_H

#include "button.h"
#include "dialog.h"
#include "optionl.h"
#include "date.h"

enum Setdatedisplay_e {
	DISPLAY_MONTHYEAR,
	DISPLAY_DAYMONTHYEAR,
	};

class Setdate : private Button , private Optionlist , public date
{
	Setdatedisplay_e displaytype;

	char *title;				// Heading label
	Optionlistinstance *d_monthlist;
	Dialoglabel d_label;
	Dialoghorizontal d_horiz;
	Dialoghorizontal d_horiz2;
	Dialogvertical d_vert;
	//
	// The registed callback handler and the value that will be 
	// passed to it.
	//
	void (*callback)(char *,class date *);
	char *callbackval;
private:
	//
	// This overrides the pure virtual button handler in the Button class
	// 
	virtual void ButtonCallback(unsigned long id,buttonstate_e flag);
	virtual void OptionlistCallback(unsigned long id);
	void Display();

public:
	void SetdateMonthyear(Dialog,void (*f)(char *,class date *),char * );
	void SetdateDaymonthyear(Dialog,void (*f)(char *,class date *),char * );
	void SetdateSettitle(char *);
	Setdate();
	Setdate(class date &indate);

	~Setdate();
};

//
// These are convenience functions
//
int
DialogSelect2dates(char *title,char *date1,date &start_date,
				char *date2,date &end_date);


#endif
