/* CHK=0xCAD9 */
/*+-------------------------------------------------------------------------
	wintty.c - kernel struct tty curses display
	wht@n4hgf.Mt-Park.GA.US

000000000011111111112222222222333333333344444444445555555555666666666677777
012345678901234567890123456789012345678901234567890123456789012345678901234
iflag: IGNBRK  BRKINT  IGNPAR  PARMRK  INPCK  ISTRIP INLCR  IGNCR   ICRNL
       IUCLC   IXON    IXOFF   IXANY
oflag: OPOST   OLCUC   ONLCR   OCRNL   ONOCR  ONLRET OFDEL
cflag: 09600-8-N-1     CREAD   HUPCL   CLOCAL
lflag: ISIG    ICANON  XCASE   ECHO    ECHOE  ECHOK  ECHONL NOFLSH  XCLUDE
       INTR QUIT ERASE KILL EOF/VMIN  EOL/VTIME EOL2 SWTCH 
cc:     03   1c   08    15    01        00       00   00   

  Defined functions:
	B_to_baud_rate(code)
	cflag_to_baud_d_p_s(cflag)
	wintty(win,tly,tlx,tty)
	wintty_template(win,tly,tlx,show_flag)

--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:08-03-1993-15:51-wht@n4hgf-source control point x2.70 */
/*:04-07-1993-15:09-wht@n4hgf-no more partially bracketed struct def */
/*:07-15-1992-14:33-wht@n4hgf-2.60 release - u386mon+siotools merge */
/*:01-29-1990-02:45-wht-add t_state display */
/*:12-28-1989-13:35-wht-B600 added */
/*:12-21-1989-15:18-wht-display CTSFLOW and RTSFLOW if defined */
/*:12-04-1989-15:40-wht-creation */

#ifndef SYSV
#define SYSV
#endif

#include <curses.h>
#ifndef TCSETA	/* 3.2v4 curses.h does not include termio.h */
#undef NL1		/* in case sgtty.h was included */
#undef CR1
#undef CR2
#undef CR3
#undef TAB1
#undef BS1
#undef FF1
#undef B50
#undef B75
#undef B110
#undef B134
#undef B150
#undef B200
#undef B300
#undef B600
#undef B1200
#undef B1800
#undef B2400
#undef B4800
#undef B9600
#undef EXTA
#undef EXTB
#undef HUPCL
#undef ECHO
#undef TIOCHPCL
#undef TIOCEXCL
#undef TIOCNXCL
#include <termio.h>
#endif
#include <sys/types.h>
#include <sys/tty.h>
#include "wintty.h"

typedef struct slabel {
	int y,x;
	char *label;
} SLABEL;

SLABEL tty_slabels[] = {
    {  0,  0, "iflag:" },
    {  2,  0, "oflag:" },
    {  3,  0, "cflag:" },
    {  4,  0, "lflag:" },
    {  5,  7, "INTR QUIT ERASE KILL EOF/VMIN  EOL/VTIME EOL2 SWTCH" },
    {  6,  0, "cc:" },
    {  7,  0, "state:" },
    {  -1,-1, (char *)0}
};

typedef struct tfield {
	int y,x;
	char *label;
	int flag_num;
	int mask;
} TFIELD;

#define IFLAG 1
#define OFLAG 2
#define LFLAG 3
#define CFLAG 4
#define STATE 5

TFIELD tty_tfields[] = {
    {  0,  7, "IGNBRK", IFLAG, IGNBRK },
    {  0, 15, "BRKINT", IFLAG, BRKINT },
    {  0, 23, "IGNPAR", IFLAG, IGNPAR },
    {  0, 31, "PARMRK", IFLAG, PARMRK },
    {  0, 39, "INPCK",  IFLAG, INPCK },
    {  0, 46, "ISTRIP", IFLAG, ISTRIP },
    {  0, 53, "INLCR",  IFLAG, INLCR },
    {  0, 60, "IGNCR",  IFLAG, IGNCR },
    {  0, 68, "ICRNL",  IFLAG, ICRNL },
    {  1,  7, "IUCLC",  IFLAG, IUCLC },
    {  1, 15, "IXON",   IFLAG, IXON },
    {  1, 23, "IXOFF",  IFLAG, IXOFF },
    {  1, 31, "IXANY",  IFLAG, IXANY },
    {  2,  7, "OPOST",  OFLAG, OPOST },
    {  2, 15, "OLCUC",  OFLAG, OLCUC },
    {  2, 23, "ONLCR",  OFLAG, ONLCR },
    {  2, 31, "OCRNL",  OFLAG, OCRNL },
    {  2, 39, "ONOCR",  OFLAG, ONOCR },
    {  2, 46, "ONLRET", OFLAG, ONLRET },
    {  2, 53, "OFDEL",  OFLAG, OFDEL },
    {  3, 23, "CREAD",  CFLAG, CREAD },
    {  3, 31, "HUPCL",  CFLAG, HUPCL },
    {  3, 39, "CLOCAL", CFLAG, CLOCAL },
#ifdef RTSFLOW
    {  3, 46, "RTSFLO", CFLAG, RTSFLOW },
#endif
#ifdef CTSFLOW
    {  3, 53, "CTSFLO", CFLAG, CTSFLOW },
#endif
    {  4,  7, "ISIG",   LFLAG, ISIG },
    {  4, 15, "ICANON", LFLAG, ICANON },
    {  4, 23, "XCASE",  LFLAG, XCASE },
    {  4, 31, "ECHO",   LFLAG, ECHO },
    {  4, 39, "ECHOE",  LFLAG, ECHOE },
    {  4, 46, "ECHOK",  LFLAG, ECHOK },
    {  4, 53, "ECHONL", LFLAG, ECHONL },
    {  4, 60, "NOFLSH", LFLAG, NOFLSH },
    {  4, 68, "XCLUDE", LFLAG, XCLUDE },
	{  7,  7, "TO",     STATE, TIMEOUT },
	{  7, 10, "WO",     STATE, WOPEN },
	{  7, 13, "O",      STATE, ISOPEN },
	{  7, 15, "TB",     STATE, TBLOCK },
	{  7, 18, "CD",     STATE, CARR_ON },
	{  7, 21, "BY",     STATE, BUSY },
	{  7, 24, "OSLP",   STATE, OASLP },
	{  7, 29, "ISLP",   STATE, IASLP },
	{  7, 34, "STOP",   STATE, TTSTOP },
	{  7, 39, "EXT",    STATE, EXTPROC },
	{  7, 43, "TACT",   STATE, TACT },
	{  7, 48, "ESC",    STATE, CLESC },
	{  7, 52, "RTO",    STATE, RTO },
	{  7, 56, "IOW",    STATE, TTIOW },
	{  7, 60, "XON",    STATE, TTXON },
	{  7, 64, "XOFF",   STATE, TTXOFF },
    {  -1,-1, (char *)0,    -1,    -1 }
};

typedef struct fcursor {
	int y,x;
} FCURSOR;

FCURSOR tty_fcursors[] = {
#define Fc_intr       0
	{  6,  8 },
#define Fcc_quit      1
	{  6, 13 },
#define Fcc_erase     2
	{  6, 18 },
#define Fcc_kill      3
	{  6, 24 },
#define Fcc_eof       4
	{  6, 30 },
#define Fcc_eol       5
	{  6, 40 },
#define Fcc_eol2      6
	{  6, 49 },
#define Fcc_swtch     7
	{  6, 54 },
#define Fbaud_b_p_s   8
	{  3,  7 }
};

typedef struct b_to_br {
	char *baud_rate;
	int B_code;
} B_TO_BR;

B_TO_BR speeds[] = {	/* ordered to put less common rates later in table */
						/* the vagaries of baud rates above 9600 "handled" */
	{ " 2400",	B2400 },
	{ " 1200",	B1200 },
	{ " 9600",	B9600 },
#if defined(B19200)
	{ "19200",	B19200 },
#endif
#if defined(B38400)
	{ "38400",	B38400 },
#endif
	{ " 4800",	B4800 },
	{ "  300",	B300 },
	{ "  110",	B110 },
	{ "  600",	B600 },
	{ "   75",	B75 },
	{ "   50",	B50 },
	{ "  HUP",	B0 },
	{ " EXTA",	EXTA },
	{ " EXTB",	EXTB },
	{ (char *)0,0 }
};

/*+-------------------------------------------------------------------------
	B_to_baud_rate(code) - convert CBAUD B_ code to baud rate string
--------------------------------------------------------------------------*/
char *
B_to_baud_rate(code)
int code;
{
	register int n;

	for(n=0; speeds[n].baud_rate; n++)
		if(speeds[n].B_code == code)
			return(speeds[n].baud_rate);
	return("-----");
}	/* end of B_to_baud_rate */

/*+-------------------------------------------------------------------------
	cflag_to_baud_d_p_s(cflag)
--------------------------------------------------------------------------*/
char *
cflag_to_baud_d_p_s(cflag)
int cflag;
{
	register char *cptr;
	static char rtnstr[16];

	strcpy(rtnstr,B_to_baud_rate(cflag & CBAUD));
	cptr = rtnstr + strlen(rtnstr);
	*cptr++ = '-';
	switch(cflag & CSIZE)
	{
		case CS5: *cptr++ = '5'; break;
		case CS6: *cptr++ = '6'; break;
		case CS7: *cptr++ = '7'; break;
		case CS8: *cptr++ = '8'; break;
	}
	*cptr++ = '-';
	*cptr++ = (cflag & PARENB) ? ((cflag & PARODD) ? 'O' : 'E') : 'N';
	*cptr++ = '-';
	*cptr++ = (cflag & CSTOPB) ? '2' : '1';
	*cptr = 0;
	return(rtnstr);

}	/* end of cflag_to_baud_d_p_s */

/*+-----------------------------------------------------------------------
	wintty(win,tly,tlx,tty)
------------------------------------------------------------------------*/
void
wintty(win,tly,tlx,tty)
WINDOW *win;
int tly;
int tlx;
struct tty *tty;
{
	register flag = 0;
	register i_cc;
	TFIELD *tptr = tty_tfields;
	FCURSOR *fptr = tty_fcursors;

	while(tptr->y >= 0)
	{
		switch(tptr->flag_num)
		{
			case IFLAG: flag = tty->t_iflag; break;
			case OFLAG: flag = tty->t_oflag; break;
			case LFLAG: flag = tty->t_lflag; break;
			case CFLAG: flag = tty->t_cflag; break;
			case STATE: flag = tty->t_state; break;
		}
		flag &= tptr->mask;
		wmove(win,tptr->y + tly,tptr->x + tlx);
		if(flag)
			wstandout(win);
		waddstr(win,tptr->label);
		if(flag)
			wstandend(win);
		tptr++;
	}
	for(i_cc = 0; i_cc < NCC; i_cc++)
	{
		wmove(win,fptr->y + tly,fptr->x + tlx);
		wprintw(win,"%02x",tty->t_cc[i_cc]);
		fptr++;
	}

	fptr = &tty_fcursors[Fbaud_b_p_s];
	wmove(win,fptr->y + tly,fptr->x + tlx);
	waddstr(win,"           ");
	wmove(win,fptr->y + tly,fptr->x + tlx);
	waddstr(win,cflag_to_baud_d_p_s(tty->t_cflag));

}	/* end of wintty */

/*+-------------------------------------------------------------------------
	wintty_template(win,tly,tlx,show_flag)
--------------------------------------------------------------------------*/
void
wintty_template(win,tly,tlx,show_flag)
WINDOW *win;
int tly;
int tlx;
int show_flag;
{
	register y;
	SLABEL *sptr = tty_slabels;

	for(y = 0; y < 7; y++)
	{
		wmove(win,tly + y,0);
		wclrtoeol(win);
	}
	if(show_flag)
	{
		while(sptr->y >= 0)
		{
			wmove(win,sptr->y + tly,sptr->x + tlx);
			waddstr(win,sptr->label);
			sptr++;
		}
	}

}	/* end of wintty_template */

/* vi: set tabstop=4 shiftwidth=4: */
/* end of wintty.c */
