
/*
 *    X SHARE MANAGER (XSM)
 *
 *    Copyright (C) 1995  David Simons
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * $Id: d_base.h,v 2.1 1995/05/18 21:14:45 davidsi Exp $
 *
 * $Log: d_base.h,v $
 * Revision 2.1  1995/05/18  21:14:45  davidsi
 * - Added a new structure (font_specifier) to allow fonts to be specified.
 * - Removed font specifications from the new_prefs structure.
 *
 * Revision 2.0  1995/04/25  21:03:04  davidsi
 * - Added support for different cursor types by providing the
 *   cursortype_e enumerated type.
 *
 * Revision 1.2  1993/01/20  22:21:58  davidsi
 * - Removed all function prototypes, now stored separately.
 *
 * Revision 1.1  1993/01/17  16:29:39  davidsi
 * Initial revision
 *
 *
 */

#ifndef _DIALOGBASE_H
#define _DIALOGBASE_H

#include "dialogcmn.h"

/*
 * Maxiumum number of fonts that may be declared
 */
#define BASE_MAX_FONT	10

typedef struct new_prefs {
	char *name;			/* name of program */
	char **argv;			/* from main() */
	int argc;			/* from main() */
	int flags;
} new_prefs;

typedef struct font_specifier {
	int npfont;			/* number of fonts being used */
	char *fname[BASE_MAX_FONT];	/* internal font names */
	char *pfont[BASE_MAX_FONT];	/* physical fonts */
} font_specifier;

enum cursortype_e {
	CURSOR_BUSY,
	CURSOR_PROP,
	CURSOR_WAIT,
	CURSOR_NORMAL,
	};




#ifdef IN_DIALOGS

typedef struct d_root {
	DIALOGHEADER
	Display *display;
	Widget main_app_shell;
	XtAppContext app_context;
	int nfonts;
	char *fname[BASE_MAX_FONT];
	XmFontList pfontlist[BASE_MAX_FONT];
	XFontStruct *pfontinfo[BASE_MAX_FONT];
} d_root;	

#endif

#endif /* _DIALOGBASE_H */
