
/*
 *    X SHARE MANAGER (XSM)
 *
 *    Copyright (C) 1995  David Simons
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _DIALOGBUT_H
#define _DIALOGBUT_H
/*
 * $Id: d_button.h,v 2.1 1995/06/06 21:59:51 davidsi Exp $
 *
 * $Log: d_button.h,v $
 * Revision 2.1  1995/06/06  21:59:51  davidsi
 * - Added GNU copyright message.
 *
 * Revision 2.0  1995/01/31  21:57:08  davidsi
 * - In new_d_tbutton, the callback function now takes a dialog and user value.
 *
 * Revision 1.5  1994/07/03  21:08:26  davidsi
 * - Fixed type declaration for callback so it will work with C++
 *
 * Revision 1.4  1993/01/20  22:21:58  davidsi
 * - Removed all function prototypes, now stored separately.
 *
 * Revision 1.3  1993/01/20  21:45:50  davidsi
 * - Changed rvalue in dialog from int to char *.
 *
 * Revision 1.2  1993/01/20  21:07:53  davidsi
 * - Updated some formatting.
 *
 * Revision 1.1  1993/01/17  16:30:25  davidsi
 * Initial revision
 *
 *
 */

typedef struct new_d_pbutton {
	char *name;
	void (*callback)(dialog, char *);
	char *value; 
} new_d_pbutton;

typedef struct new_d_tbutton {
	long flags;
	char *name;
	char ivalue;
	void (*callback)(dialog, char *);
	char *value;
} new_d_tbutton;

#define DIALOG_TBUTTON_MUTEX	1

#ifdef IN_DIALOGS
#include "dialogcmn.h"

typedef struct d_pbutton {
	DIALOGHEADER
	void (*callback)();
	char * rvalue;
} d_pbutton;

typedef struct d_tbutton {
	DIALOGHEADER
	void (*callback)();
	char *rvalue;
} d_tbutton;

#endif

#endif /* _DIALOGBUT_H */
