/*
 * $Id: d_contain.c,v 1.1 1993/01/17 16:31:20 davidsi Exp $
 *
 * $Log: d_contain.c,v $
 * Revision 1.1  1993/01/17  16:31:20  davidsi
 * Initial revision
 *
 *
 */

/*
 * Include Files
 */
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/RowColumn.h>

#define IN_DIALOGS

#include "d_base.h"
#include "d_contain.h"
#include "d_form.h"


/*
 * Variable Declarations 
 */
static char rcsid[]="$Id: d_contain.c,v 1.1 1993/01/17 16:31:20 davidsi Exp $";

/*
 * dialog_containv parent position
 *
 * Creates a container for dialogs which will vertically stack all child
 * dialogs.
 *
 * INPUTS :	parent		The parent of the dialog to create
 *		position	Position information for this dialog
 * RETURNS:	A pointer to the newly created dialog
 */
dialog
dialog_containv(parent,p)
dialog parent;
position *p;
{
d_containv *contain;
Arg al[20];
int ac;

    contain=(d_containv *)dialog_init(parent,sizeof(d_containv));
    ac=0;
    if (p) 
	dialog_position(p,al,&ac);
    contain->widget=XmCreateRowColumn(parent->widget,"",al,ac);
    return((dialog)contain);
}


/*
 * dialog_containh parent position
 *
 * Creates a container for dialogs which will horizontally stack all child
 * dialogs.
 *
 * INPUTS :	parent		The parent of the dialog to create
 *		position	Position information for this dialog
 * RETURNS:	A pointer to the newly created dialog
 */
dialog
dialog_containh(parent,p)
dialog parent;
position *p;
{
d_containv *contain;
Arg al[20];
int ac;

    contain=(d_containv *)dialog_init(parent,sizeof(d_containh));
    XtSetArg(al[0],XmNorientation,XmHORIZONTAL);
    ac=1;
    if (p) 
	dialog_position(p,al,&ac);
    contain->widget=XmCreateRowColumn(parent->widget,"",al,ac);
    return((dialog)contain);
}

/*
 * dialog_containsize parent width height
 *
 * Creates a container for dialogs which will vertically stack all child
 * dialogs. The container is of the specified size.
 *
 * INPUTS :	parent		The parent of the dialog to create
 *		width		The width of the container
 *		height		The height of the container
 * RETURNS:	A pointer to the newly created dialog
 */
dialog
dialog_containsize(parent,width,height)
dialog parent;
int width,height;
{
d_containv *contain;
Arg al[10];

    contain=(d_containv *)dialog_init(parent,sizeof(d_containv));
    XtSetArg(al[0],XmNresizeWidth,FALSE);
    XtSetArg(al[1],XmNresizeHeight,FALSE);
    XtSetArg(al[2],XmNwidth,width);
    XtSetArg(al[3],XmNheight,height);
    contain->widget=XmCreateRowColumn(parent->widget,"",al,4);
    return((dialog)contain);
}
