/*
 * $Id: d_edit.c,v 2.0 1995/04/16 19:54:12 davidsi Exp $
 *
 * $Log: d_edit.c,v $
 * Revision 2.0  1995/04/16  19:54:12  davidsi
 * - dialog_edit_set() now moves the cursor to the end of the string, and
 *   because XmNautoShowCursorPosition is set the text will scroll to
 *   the display the botton of the text.
 *
 * Revision 1.2  1994/07/14  20:18:00  davidsi
 * - BUG FIX. Many of the globally visible functions were incorrectly
 *   typed.
 *
 * Revision 1.1  1993/01/20  21:02:21  davidsi
 * Initial revision
 *
 *
 */


/*
 * Include Files
 */
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/RowColumn.h>
#include <Xm/Text.h>

#define IN_DIALOGS

#include "d_base.h"
#include "d_edit.h"
#include "d_form.h"


/*
 * Variable Declarations 
 */
static char rcsid[]="$Id: d_edit.c,v 2.0 1995/04/16 19:54:12 davidsi Exp $";

/*
 * dialog_edit_value dialog
 *
 * Determines the string that has been entered into an edit dialog.
 *
 * INPUTS :	dialog	The edit dialog whose string is req'd
 * RETURNS:	The string that has been entered by the user
 */
char *
dialog_edit_value(d_e)
dialog d_e;
{
	Arg al[10];
	char *str;

	XtSetArg(al[0],XmNvalue,&str);
	XtGetValues(d_e->widget,al,1);
	return(str);
}

/*
 * dialog_edit_set dialog textstring
 *
 * Sets the string for a edit dialog
 *
 * INPUTS :	dialog		The edit dialog whose data is to change
 *		textstring	The text string to be used
 * RETURNS:	None
 */
void
dialog_edit_set(d_e,text)
dialog d_e;
char *text;
{
	Arg al[1];

	XmTextSetString(d_e->widget,text);

	XtSetArg(al[0],XmNcursorPosition,strlen(text));
	XtSetValues(d_e->widget,al,1);
}


/*
 * dialog_edit parent, newedit, position
 *
 * Creates a dialog that allows user to enter text.
 *
 * INPUTS :	parent		The parent dialog
 *		newedit		The new edit structure
 *		position	Describes position of the dialog in
 *				the parent dialog
 * RETURNS:	A pointer to the newly created dialog.	
 */
dialog
dialog_edit(d,newedit,p)
dialog d;
new_d_edit *newedit;
position *p;
{
	Arg al[20];
	d_edit *d_e;
	int ac;

	d_e=(d_edit *)dialog_init(d,sizeof(d_edit));

	XtSetArg(al[0], XmNrows,newedit->rows);
	XtSetArg(al[1], XmNcolumns,newedit->cols);
	XtSetArg(al[2], XmNeditMode, XmMULTI_LINE_EDIT);
	if (newedit->flags & DIALOG_EDIT_RONLY)
		XtSetArg(al[3], XmNeditable, FALSE);
	else
		XtSetArg(al[3], XmNeditable, TRUE);
	ac=4;
	if (newedit->value) {
		XtSetArg(al[ac], XmNvalue,newedit->value);
		ac++;
	}
	XtSetArg(al[ac], XmNautoShowCursorPosition, TRUE);
	ac++;
	if (p) 
		dialog_position(p,al,&ac);
	XtManageChild(d_e->widget=XmCreateScrolledText(d->widget, "text",al,ac));
	return((dialog)d_e);
}
