/*
 * $Id: d_label.c,v 1.3 1994/02/09 22:08:09 davidsi Exp $
 *
 * $Log: d_label.c,v $
 * Revision 1.3  1994/02/09  22:08:09  davidsi
 * - If a font is specified in the new_label structure then use that font.
 *
 * Revision 1.2  1993/01/31  18:47:13  davidsi
 * - Added dialog_label_change() to allow changes to be made to the
 *   text that is being displayed.
 *
 * Revision 1.1  1993/01/20  20:55:09  davidsi
 * Initial revision
 *
 *
 */


/*
 * Include Files
 */
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/Label.h>

#define IN_DIALOGS

#include "d_base.h"
#include "d_label.h"
#include "d_form.h"


/*
 * Variable Declarations 
 */
static char rcsid[]="$Id: d_label.c,v 1.3 1994/02/09 22:08:09 davidsi Exp $";

/*
 * dialog_label_change parent, newstring
 *
 * Modifies a dialog to show a new string.
 *
 * INPUTS :	parent		The label dialog
 *		newstring	The string to display
 * RETURNS:	None
 */
dialog
dialog_label_change(parent,newstring)
dialog parent;
char *newstring;
{
Arg al[10];
XmString str;

    str=XmStringCreateLtoR(newstring,XmSTRING_DEFAULT_CHARSET);
    XtSetArg(al[0],XmNlabelString,str);
    XtSetValues(parent->widget,al,1);
    XmStringFree(str);

}




/*
 * dialog_label parent, string, position
 *
 * Creates a dialog that shows a string.
 *
 * INPUTS :	parent		The parent dialog
 *		string		The string to display
 *		position	Describe position of string in parent dialog
 * RETURNS:	A pointer to the newly created dialog.	
 */
dialog
dialog_label(parent,lptr,p)
dialog parent;
new_label *lptr;
position *p;
{
d_label *label;
Arg al[10];
int ac;

    label=(d_label *)dialog_init(parent,sizeof(d_label));
    ac=0;
    if (p)
	dialog_position(p,al,&ac);
    /*
     * If a font was specified set it now
     */
    if (lptr->fname) {
	XtSetArg(al[0],XmNfontList,fname_2_fontlist(lptr->fname));
	ac++;
    }
    label->widget=XmCreateLabel(parent->widget, lptr->name, al, ac);
    return((dialog)label);
}
