#ident "$RCSfile: d_list.c,v $"
/*
 * $Id: d_list.c,v 1.1 1994/10/18 20:15:22 davidsi Exp $
 *
 * $Log: d_list.c,v $
 * Revision 1.1  1994/10/18  20:15:22  davidsi
 * Initial revision
 *
 *
 *
 */


/*
 * Include Files
 */
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/SelectioB.h>
#include <Xm/List.h>

#define IN_DIALOGS

#include "d_base.h"
#include "d_list.h"
#include "d_form.h"


/*
 * Variable Declarations 
 */
static char rcsid[]="$Id: d_list.c,v 1.1 1994/10/18 20:15:22 davidsi Exp $";



/*
 * dialog_optionlist_d dialog
 *
 * Destroys an optionlist, freeing all the necessary resources.
 *
 * INPUTS :	dialog		The dialog to destroy
 * RETURNS:	None
 */
static void
dialog_list_d(l_ptr)
d_list *l_ptr;
{
int iter;

    for(iter=0;iter<l_ptr->nlist;iter++)  {
	free(l_ptr->list[iter]);
	XmStringFree(l_ptr->xmlist[iter]);
    }
    free(l_ptr->list);
    free(l_ptr->xmlist);
    XtDestroyWidget(l_ptr->widget);
}

char **
dialog_list_items(d,lsize)
dialog d;
int *lsize;
{
d_list *l_ptr=(d_list *)d;
Arg al[10];		/* arg list */
int iter;
char **stringptr,**sp;
Widget w=l_ptr->widget;
XmString *items;
int numitems;


	XtSetArg(al[0],XmNselectedItemCount,&numitems);
	XtSetArg(al[1],XmNselectedItems,&items);
	XtGetValues(w,al,2);

        sp=stringptr=(char **)malloc(sizeof(char *)*(numitems+1));

	for(iter=0;iter<numitems;iter++) {
		XmStringGetLtoR(items[iter],XmSTRING_DEFAULT_CHARSET,sp);
		sp++;
	}
	*sp=NULL;
	if (lsize)
		*lsize=numitems;
	return(stringptr);
}


/*
 * dialog_optionlist dialog new_option
 *
 * Creates a option list dialog
 *
 * INPUTS :	dialog		The parent dialog 
 *		nopt		The new option list structure
 * RETURNS:	A pointer to the newly created dialog
 */
dialog
dialog_list(parent,nopt)
dialog parent;
new_list *nopt;
{
Arg al[20];		/* arg list */
int iter;
d_list *l_ptr;
int n;
int num;
char **str;


	l_ptr=(d_list *)dialog_init(parent,sizeof(d_list));
	/*
	 * Determine number of items in list
	 */
	str=nopt->list_item;
	num=0;
	while (*str) {
		str++;
		num++;
	}
	/*
	 * And copy into the List class
	 */
	l_ptr->list=(char **)malloc(sizeof(char *)*(num+1));
	l_ptr->xmlist=(XmString *)malloc(sizeof(XmString)*(num+1));
	l_ptr->nlist=num;
	l_ptr->fname=nopt->fname;
	for(iter=0;iter<num;iter++) {
		l_ptr->list[iter]=(char *)malloc(strlen(nopt->list_item[iter])+1);
		strcpy(l_ptr->list[iter],nopt->list_item[iter]);
		l_ptr->xmlist[iter]=(XmString)XmStringCreateLtoR(
						nopt->list_item[iter],
						XmSTRING_DEFAULT_CHARSET);
	}
	l_ptr->list[iter]=NULL;
	/*
	 * Copy user settings
	 */
	bcopy(nopt,&(l_ptr->user),sizeof(new_list));

	n=0;
	XtSetArg(al[n],XmNtextColumns,nopt->width);n++;
	if (num!=0) {
		XtSetArg(al[n],XmNitems, l_ptr->xmlist);n++;
	} else {
		XtSetArg(al[n],XmNitems, NULL);n++;
	}
	XtSetArg(al[n],XmNitemCount,num);n++;
	XtSetArg(al[n],XmNvisibleItemCount,nopt->height);n++;
	XtSetArg(al[n],XmNuserData,l_ptr);n++;
	XtSetArg(al[n],XmNscrollBarDisplayPolicy,XmSTATIC);n++;
	XtSetArg(al[n],XmNselectionPolicy,XmEXTENDED_SELECT);n++;
	l_ptr->widget=XmCreateScrolledList(parent->widget,"wid",al,n);
	
	/*
	 * If a font was specified for the list set it now
	*/
	if (l_ptr->fname) {
		XtSetArg(al[0],XmNfontList,fname_2_fontlist(l_ptr->fname));
		XtSetValues(l_ptr->widget,al,1);
	}
	l_ptr->destroy=dialog_list_d;
	return((dialog)l_ptr);
}
