
/*
 *    X SHARE MANAGER (XSM)
 *
 *    Copyright (C) 1995  David Simons
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _DIALOGMENU_H
#define _DIALOGMENU_H
/*
 * $Id: d_menu.h,v 2.1 1995/06/06 22:06:54 davidsi Exp $
 *
 * $Log: d_menu.h,v $
 * Revision 2.1  1995/06/06  22:06:54  davidsi
 * - Added GNU copyright message.
 *
 * Revision 2.0  1995/01/19  22:13:30  davidsi
 * - To allow dynamic updating of menus, the menu_bar Widget must
 *   now be stored ready for reuse.
 *
 * Revision 1.3  1994/10/18  20:14:01  davidsi
 * - Added MENUTYPE_ENABLED.
 *
 * Revision 1.2  1993/01/20  22:21:58  davidsi
 * - Removed all function prototypes, now stored separately.
 *
 * Revision 1.1  1993/01/20  21:08:10  davidsi
 * Initial revision
 *
 *
 */

#ifdef IN_DIALOGS

#include "dialogcmn.h"

typedef struct d_menub {
	DIALOGHEADER
	struct d_menub *next;
	struct d_menub *last;
	char *name;
	struct d_menu *mitem;
	struct d_menu *last_mitem;
	Widget menu_bar;
	int flags;				/* see MENUTYPE_XXX */
} d_menub;

typedef struct d_menu {
	DIALOGHEADER
	struct d_menu *next;
	char *name;
	void (*callback)();
	long value;
	int flags;				/* see MENUI_XX */
} d_menu;

#endif


/*
 * Types that can be passed when creating a menu item
 */ 
#define MENUI_ACTION		1
#define MENUI_NOFMANY		2
#define MENUI_ONEOFMANY		4
#define MENUI_ENABLED		8		/* item is enabled as default */

/*
 * Types that can be passed when creating a menu on a menu bar
 */ 
#define MENUTYPE_ACTION		MENUI_ACTION
#define MENUTYPE_NOFMANY	MENUI_NOFMANY
#define MENUTYPE_ONEOFMANY	MENUI_ONEOFMANY
#define MENUTYPE_MASK		(MENUTYPE_ACTION|MENUTYPE_NOFMANY|MENUTYPE_ONEOFMANY)
#define MENUTYPE_ENABLED	MENUI_ENABLED
#endif /* _DIALOGMENU_H */
