
/*
 *    X SHARE MANAGER (XSM)
 *
 *    Copyright (C) 1995  David Simons
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _DIALOGOPTL_H
#define _DIALOGOPTL_H
/*
 * $Id: d_optionl.h,v 2.0 1995/06/06 22:07:41 davidsi Exp $
 *
 * $Log: d_optionl.h,v $
 * Revision 2.0  1995/06/06  22:07:41  davidsi
 * - Added GNU copyright message.
 *
 * Revision 1.3  1994/07/03  21:17:22  davidsi
 * - Modified new_optionlist.  Update the select declaration to allow
 *   C++ compiler to type check correctly. Change callvalue from a long
 *   to a char * - again for type checking purposes.  Remove num field
 *   because the list is now assumed to be NULL terminated.
 *
 * Revision 1.2  1993/01/20  22:21:58  davidsi
 * - Removed all function prototypes, now stored separately.
 *
 * Revision 1.1  1993/01/20  21:08:10  davidsi
 * Initial revision
 *
 *
 */



typedef struct new_optionlist {
	int width;
	int height;
	char **list_item;
	char *listname;
	char *selname;
	void (*select)(dialog, char *);
	char *callvalue;
	int flags;
	char *fname;				/* name of font for list */
} new_optionlist;

#define OPTION_LIST_SEARCH	1
#define OPTION_LIST_AUTOP	2
#define	OPTION_LIST_NOTEXT	4
#define	OPTION_LIST_NOLABEL	8

#ifdef IN_DIALOGS
#include "dialogcmn.h"

typedef struct d_optionl {
	DIALOGHEADER
	char **list;
	XmString *xmlist;
	int nlist;
	new_optionlist user;
	long callvalue;
	char *fname;				/* name of font for list */
} d_optionl;

#endif

#endif /* _DIALOGOPTL_H */
