
/*
 *    X SHARE MANAGER (XSM)
 *
 *    Copyright (C) 1995  David Simons
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * $Id: d_shell.h,v 2.2 1995/06/06 21:50:22 davidsi Exp $
 *
 * $Log: d_shell.h,v $
 * Revision 2.2  1995/06/06  21:50:22  davidsi
 * - Removed the support for dialog_shell_unmanage() - see d_shell.c
 *   for the full story.
 *
 * Revision 2.1  1995/05/18  21:10:37  davidsi
 * - Added unmanageforce to the d_shell structure, so unmanage requests can
 *   be tracked.
 *
 * Revision 2.0  1995/01/19  22:12:11  davidsi
 * - Added SHELL_SCROLL to allow shells with scrollbars
 *
 * Revision 1.3  1993/01/20  23:05:57  davidsi
 * - Missing comment terminator at end of file.
 *
 * Revision 1.2  1993/01/20  22:21:58  davidsi
 * - Removed all function prototypes, now stored separately.
 *
 * Revision 1.1  1993/01/20  21:08:10  davidsi
 * Initial revision
 *
 *
 */
#ifndef _DIALOGSHELL_H
#define _DIALOGSHELL_H



/*
 * Types of shell - passed as flags value
 */
#define SHELL_MAINWINDOW	0x1
#define SHELL_POPUP		0x2

/*
 * These can be applied to the shells above
 */
#define SHELL_SCROLL		0x1000	/* only for SHELL_MAINWINDOW */

#ifdef IN_DIALOGS

#include "dialogcmn.h"

typedef struct d_shell {
	DIALOGHEADER
	Widget toplevel;
} d_shell;

#endif

#endif /* _DIALOGSHELL_H */
