
/*
 *    X SHARE MANAGER (XSM)
 *
 *    Copyright (C) 1995  David Simons
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _DIALOGCMN_H 
#define _DIALOGCMN_H
/*
 * $Id: dialogcmn.h,v 2.0 1995/06/06 22:08:22 davidsi Exp $
 *
 * $Log: dialogcmn.h,v $
 * Revision 2.0  1995/06/06  22:08:22  davidsi
 * - Added GNU copyright message.
 *
 * Revision 1.2  1993/01/20  22:21:58  davidsi
 * - Removed all function prototypes, now stored separately.
 *
 * Revision 1.1  1993/01/20  21:08:10  davidsi
 * Initial revision
 *
 */

/*
 * Everything in this file is visible to users of the library unless
 * explicitly undefined for external users!
 */
#ifdef IN_DIALOGS

#define DIALOGHEADER			\
struct dialog *parent;			\
struct dialog *child;			\
struct dialog *sibling_f;		\
struct dialog *sibling_b;		\
void (*destroy)();			\
void (*realise)();			\
Widget widget;				\
int privateflags;			\

/*
 * values for flags field
 */
#define DIALOG_BASENODE	1	/* dialog should be teated as a base node */
#define DIALOG_REALISED	2	/* dialog has been realised */


typedef struct dialog {
	DIALOGHEADER
} *dialog;
#else
typedef char *dialog;
#endif

#endif /* _DIALOGCMN_H */
