
//
//    X SHARE MANAGER (XSM)
//
//    Copyright (C) 1995  David Simons
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//


//
// $Id: slist.h,v 2.1 1995/05/18 20:20:35 davidsi Exp $
//
// $Log: slist.h,v $
// Revision 2.1  1995/05/18  20:20:35  davidsi
// - Added SlistSetpath() so that paths can be specified for the files
//   that store the data on the disk.
// - SlistMakeconsistent() now builds the complete file path.
// - SlistCopycallbacks() allows callbacks to be copied from one slist
//   instance to another.
//
//
//

#ifndef __SLIST_H
#define __SLIST_H

#include "list.h"
#include "callback.h"
#include "record.h"

//
// Defines for mode in set_filename
//
#define WRITE_BY_LINE	1
#define WRITE_BY_SIZE	2
#define WRITE_BY_PERC	3


class slist_node : public list_node {
public:
	virtual void save_record(class record *);

	//
	// These are to save casts
	//
	class slist_node *next();
};

class slist : public list {
	class callback load_vect;
	char *filename;			// name of file
	char *pathname;			// directory component
	char *fullpath;			// full directory and file path
	unsigned long mode;

private:
	void SlistMakeconsistent();
protected:
	void set_filename(char *,unsigned long mode);
public:
	void SlistSetpath(char *);
	void SlistCopycallbacks(class slist &);
	void save();
	void load();
	void add_load_vect( void (* f)( char *,va_list ) );
        virtual char *version();

	slist();
	virtual ~slist();
};


#endif
