/*
02/16/94  slh  -m and -c switches; update for IscGetHoldingStatus() change
10/26/93  slh  use/list -w switch; make 0 default width
   - 10/27/93    -o switch
09/07/93  slh  add for IscGetHoldingStatus(): interface change
08/23/93  slh  -v and -d switch
08/17/93  slh  -help; fixed bogus wrong # of params msg
 7/ 2/93  slh  update for IscGetHoldingStatus() interface change
 6/ 9/93,  6/22/93,  6/23/93  slh
slh

cc -o iscd iscd.c isc.c
*/
#define  SZVERSION	\
	"driver date 1994/02/16 [isc module version 0.30:1994/02/16 or newer]"
#define  SZFMTUSAGE	"usage: %s [-h] [-help] [-v] \
[-d] [-t] [+t] [-n] [+n] [-s] [+s] [-i <indent>] [-w <width>] [-o <timeout>] \
[-m <mode>] [-c <server>] [<opcode>] <request>\n"
#define  SZFMTHELP	"\
Options:\n\
  -h		help		: print usage\n\
  -help		HELP		: print (this) longer help message\n\
  -v		verbose/version	: displays version number and maybe extra\n\
  -d		dump		: dump associated MARC record instead\n\
  -t		titles		: output title section\n\
  +t		no titles	: do not output title section\n\
  -n		non-ascii	: include non-ascii chars in title output\n\
  +n		no non-ascii	: \
do not include non-ascii chars in title output\n\
  -s		short labels	: use short/abbreviated labels\n\
  +s		long labels	: use long labels\n\
  -i <indent>	indent		: number of chars of indentation\n\
  -w <width>	width		: width of output in characters\n\
  -o <timeout>	timeout		: timeout for connects/read (secs)\n\
  -m <mode>	mode		: LCAT (default) or GCAT or ...\n\
  -c <server>	host		: circ server\n\
Parameters:\n\
  <opcode>	(char) opcode request\n\
  <request>	(string) query argument\n\
Options must appear before parameters.\n\
"


#include  <stdlib.h>
#include  <stdio.h>

#include  "isc.h"


#ifndef  FALSE
#define  FALSE	0
#define  TRUE	1
#endif/*!FALSE*/


int  main  (int		argc	,
	    char**	argv	)
{
  int		s;
  int		fError;
  int		cRecord, cRemain, Error;
  char		*pszProg;
/* Variable */
  char		*vchData	= (char*)NULL;
  int		 cchData	= 0;
  int		fErrorState	= FALSE;
  int		Code		= 0;
  int		fUsage		= FALSE;
  int		fHelp		= FALSE;
  int		fVerbose	= FALSE;
  int		fDump		= FALSE;
  int		fTitle		= TRUE;
  int		fNonAscii	= TRUE;
  int		nchLine		= -1;		/* do not wrap */
  int		fShortLabels	= FALSE;
  int		nchIndent	= -1;		/* use label widths */
  int		Timeout		= -1;		/* don't set */
  char		*pszMode	= (char*)NULL;	/* use default */
  char		*pszServer	= "denali.lib.washington.edu";
  char		*pszCode	= (char*)NULL;
  char		*pszRequest	= (char*)NULL;

  pszProg = *argv;
  argv++;  argc--;

  while (!Code && argc && (**argv == '-' || **argv == '+')) {
    if        (!strcmp( *argv , "-h" )) {
      fUsage	= TRUE;
    } else if (!strcmp( *argv , "-help" )) {
      fUsage	= TRUE;
      fHelp	= TRUE;
    } else if (!strcmp( *argv , "-v" )) {
      fVerbose	= TRUE;
    } else if (!strcmp( *argv , "-d" )) {
      fDump	= TRUE;
    } else if (!strcmp( *argv , "-t" )) {
      fTitle	= TRUE;
    } else if (!strcmp( *argv , "+t" )) {
      fTitle	= FALSE;
    } else if (!strcmp( *argv , "-n" )) {
      fNonAscii	= TRUE;
    } else if (!strcmp( *argv , "+n" )) {
      fNonAscii	= FALSE;
    } else if (!strcmp( *argv , "-s" )) {
      fShortLabels	= TRUE;
    } else if (!strcmp( *argv , "+s" )) {
      fShortLabels	= FALSE;
    } else if (!strcmp( *argv , "-i" )) {
      argv++;  argc--;

      if (argc) {
	nchIndent	= atoi( *argv );
      } else {
	(void)fprintf( stderr , "%s: missing value for option\n" , pszProg );
	Code = 1;
	fUsage = TRUE;
      }
    } else if (!strcmp( *argv , "-w" )) {
      argv++;  argc--;

      if (argc) {
	nchLine	= atoi( *argv );
      } else {
	(void)fprintf( stderr , "%s: missing value for option\n" , pszProg );
	Code = 1;
	fUsage = TRUE;
      }
    } else if (!strcmp( *argv , "-o" )) {
      argv++;  argc--;

      if (argc) {
	Timeout	= atoi( *argv );
      } else {
	(void)fprintf( stderr , "%s: missing value for option\n" , pszProg );
	Code = 1;
	fUsage = TRUE;
      }
    } else if (!strcmp( *argv , "-m" )) {
      argv++;  argc--;

      if (argc) {
	pszMode		= *argv;
      } else {
	(void)fprintf( stderr , "%s: missing value for option\n" , pszProg );
	Code = 1;
	fUsage = TRUE;
      }
    } else if (!strcmp( *argv , "-c" )) {
      argv++;  argc--;

      if (argc) {
	pszServer	= *argv;
      } else {
	(void)fprintf( stderr , "%s: missing value for option\n" , pszProg );
	Code = 1;
	fUsage = TRUE;
      }
    } else {
      (void)fprintf( stderr , "%s: unknown option: %s\n" , pszProg , *argv );
      Code = 1;
      fUsage = TRUE;
    }

    argv++;  argc--;
  }

  if (fVerbose)
    (void)fprintf( stdout , "%s\n" , SZVERSION );

  if (fUsage) {
    (void)fprintf( Code ? stderr : stdout , SZFMTUSAGE , pszProg );
    if (fHelp)
      (void)fprintf( Code ? stderr : stdout , SZFMTHELP );
    exit( Code );
  }

  if (argc != 2 && argc != 1) {
    (void)fprintf( stderr , "%s: wrong number of parameters\n" , pszProg );
    (void)fprintf( stderr , SZFMTUSAGE , pszProg );
    exit( 1 );
  }

  if (argc == 2) {
    pszCode = *argv;
    argv++;  argc--;
  }
  pszRequest = *argv;
  argv++;  argc--;

  if (Timeout != -1)
    IscSetParams( Timeout );

  if (0 > (s = IscInit( pszServer ))) {
    (void)fprintf( stderr , "%s: counldn't contact server\n" , pszProg );
    exit( 1 );
  }

  if (pszCode) {
    if (!IscQuery( s , *pszCode , pszRequest ,
		   &fError , &cRecord , &cRemain , &Error ,
		   &vchData , &cchData )) {
      (void)fprintf( stderr , "%s: IscQuery() failed\n" , pszProg );
      fErrorState = TRUE;
    } else {
      if (!fError) {
	(void)fprintf( stdout , "Records:\t%d\n" , cRecord );
	(void)fprintf( stdout , "Remains:\t%d\n" , cRemain );
	if (!fDump)
	  (void)fprintf( stdout , "%d\n%.*s\n" , cchData , cchData , vchData );
	else
	  (void)IscDumpMarcRecord( stdout , vchData , cchData );

      } else {
	(void)fprintf( stdout , "Error:\t\t%d\t%.*s\n" ,
		       Error , cchData , vchData );
      }

      free( vchData );
    }
  } else {
    if (!fDump)
      if (!IscGetHoldingStatus( s , pszMode , pszRequest ,
			        fTitle , fNonAscii , nchLine ,
			        fShortLabels , nchIndent ,
			        &vchData , &cchData )) {
	(void)fprintf( stderr , "%s: IscGetHoldingStatus() failed\n" ,
		       pszProg );
	fErrorState = TRUE;
      } else {
	(void)fprintf( stdout , "%s" , vchData );
      }
    else
      if (!IscQuery( s , '.' , pszRequest ,
		     &fError , &cRecord , &cRemain , &Error ,
		     &vchData , &cchData )) {
	(void)fprintf( stderr , "%s: IscQuery() failed\n" , pszProg );
	fErrorState = TRUE;
      } else {
	if (!fError) {
	  (void)IscDumpMarcRecord( stdout , vchData , cchData );
	} else {
	  (void)fprintf( stdout , "Error:\t\t%d\t%.*s\n" ,
			 Error , cchData , vchData );
	}
      }
    free( vchData );
  }

  IscTerm( s );
  exit( fErrorState );
}
