/***********************************************************************
 *                                                                     *
 *              WILLOW(tm) Information Retrieval Software              *
 *     (Washington Information Looker-upper Layered Over Windows)      *
 *             Copyright 1992-1994 University of Washington            *
 *                                                                     *
 *   Willow is a trademark of the University of Washington.  No        *
 *   commercial use of this trademark or software may be made without  *
 *   prior written permission of the University of Washington.         *
 *                                                                     *
 * Permission to use, copy, modify, and distribute Willow(tm) software *
 * and its documentation for any noncommercial purpose is hereby       *
 * granted, provided that the above copyright notice appears in all    *
 * copies and that both the above copyright notice and this permission *
 * notice appear in supporting documentation, and that the name of the *
 * University of Washington not be used in advertising or publicity    *
 * pertaining to distribution of the software without specific,        *
 * written prior permission.  This software is made available "as is", *
 * and THE UNIVERSITY OF WASHINGTON DISCLAIMS ALL WARRANTIES, EXPRESS  *
 * OR IMPLIED, WITH REGARD TO THIS SOFTWARE, INCLUDING WITHOUT         *
 * LIMITATION ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS    *
 * FOR A PARTICULAR PURPOSE, AND IN NO EVENT SHALL THE UNIVERSITY OF   *
 * WASHINGTON BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL     *
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA  *
 * OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, TORT (INCLUDING       *
 * NEGLIGENCE) OR STRICT LIABILITY, ARISING OUT OF OR IN CONNECTION    *
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.                       *
 *                                                                     *
 * For further information please contact:                             *
 * Willow Project                                                      *
 * Information Systems                                                 *
 * University of Washington                                            *
 * 4545 15th NE, 1st floor                                             *
 * Seattle, Washington, 98105, USA                                     *
 * Internet: willow@cac.washington.edu                                 *
 ***********************************************************************/

/***************************************************
 * dict.h
 * Declarations for the list browser.
 ***************************************************/

/* Types of browses */
#define HEADER   1
#define INCR     2
#define SCROLL   3
#define FIRST    4

typedef struct _browse_q_rec { /* Structure for queueing sent requests */
  int ref_num;
  int browse_type;
  int scroll_to; /* Only needed for SCROLL type */
  struct _browse_q_rec *next, *prev;
} browse_q_rec;

#define SEP 0x1e
#define MAX_FIELDS   16
#define MAX_RECORDS  256

#define MAX_NAME_LEN  64
#define MAX_FIELD_LEN 1024
#define TEXT_SIZE    10000
#define DFLT_OP      " OR "

typedef struct _field_def {
  char name[MAX_NAME_LEN];
  int  max_len;
  int  pos;
  int  val_dex;
  Boolean browsable;
  Boolean searchable;
  Boolean vis_value;
  Boolean vis_label;
  Boolean rjust;
} field_def;

typedef struct _record_def {
  char *ret_ptr;                   /* Pointer to string to get returned */
  char *disp_ptr;                  /* Pointer to string to get displayed */
} record_def;

typedef struct _sel_rec_def { /* structure for off-screen selections */
  char *ret_value;
  char *disp_value;
  int   real_pos;
  struct _sel_rec_def *next;
} sel_rec_def;
