/***********************************************************************
 *                                                                     *
 *              WILLOW(tm) Information Retrieval Software              *
 *     (Washington Information Looker-upper Layered Over Windows)      *
 *             Copyright 1992-1994 University of Washington            *
 *                                                                     *
 *   Willow is a trademark of the University of Washington.  No        *
 *   commercial use of this trademark or software may be made without  *
 *   prior written permission of the University of Washington.         *
 *                                                                     *
 * Permission to use, copy, modify, and distribute Willow(tm) software *
 * and its documentation for any noncommercial purpose is hereby       *
 * granted, provided that the above copyright notice appears in all    *
 * copies and that both the above copyright notice and this permission *
 * notice appear in supporting documentation, and that the name of the *
 * University of Washington not be used in advertising or publicity    *
 * pertaining to distribution of the software without specific,        *
 * written prior permission.  This software is made available "as is", *
 * and THE UNIVERSITY OF WASHINGTON DISCLAIMS ALL WARRANTIES, EXPRESS  *
 * OR IMPLIED, WITH REGARD TO THIS SOFTWARE, INCLUDING WITHOUT         *
 * LIMITATION ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS    *
 * FOR A PARTICULAR PURPOSE, AND IN NO EVENT SHALL THE UNIVERSITY OF   *
 * WASHINGTON BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL     *
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA  *
 * OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, TORT (INCLUDING       *
 * NEGLIGENCE) OR STRICT LIABILITY, ARISING OUT OF OR IN CONNECTION    *
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.                       *
 *                                                                     *
 * For further information please contact:                             *
 * Willow Project                                                      *
 * Information Systems                                                 *
 * University of Washington                                            *
 * 4545 15th NE, 1st floor                                             *
 * Seattle, Washington, 98105, USA                                     *
 * Internet: willow@cac.washington.edu                                 *
 ***********************************************************************/

/****************************************************************
 * resources.h
 * Various definitions used for setting up resources.
 ****************************************************************/

#define MIN_SCREEN_WIDTH 1000
#define MIN_SCREEN_HEIGHT 700
#define SMALL_SEARCH_GM "420x285+1+10"  
#define SMALL_SUMM_GM	"600x330+0-0"   
#define SMALL_LIST_GM	"440x288+1+10"  
#define SMALL_FULL_GM	"516x418-0+10"
#define SMALL_HELP_GM   "+1+10"
#define SMALL_DEFAULT_FT "-adobe-helvetica-bold-r*100-75*" 
/*#define SMALL_BUTTON_FT  "-adobe-courier-bold-r*100-75*"   */
#define SMALL_BUTTON_FT  "-adobe-helvetica-bold-r*100-75*" 
#define SMALL_TEXT_FT    "-adobe-courier-medium-r*100-75*"
#define SMALL_VERT_SPACING  "1"
#define SMALL_FIELD_OFFSET  "4" 
#define SMALL_HORIZ_SPACING "2"
#define SMALL_DIALOG_VERT_SPACING  "4"
#define SMALL_DIALOG_HORIZ_SPACING "4"

#define MEDIUM_SEARCH_GM "500x325+0+1"  
#define MEDIUM_SUMM_GM	 "695x434+0+360"   
#define MEDIUM_LIST_GM	 "510x340+100+320"  
#define MEDIUM_FULL_GM	 "590x650+500+1"
#define MEDIUM_HELP_GM   "+70+70"
#define MEDIUM_DEFAULT_FT "-adobe-helvetica-bold-r*120-75*"
/*#define MEDIUM_BUTTON_FT  "-adobe-courier-bold-r*120-75*"*/
#define MEDIUM_BUTTON_FT  "-adobe-helvetica-bold-r*120-75*"
#define MEDIUM_TEXT_FT    "-adobe-courier-medium-r*120-75*"
#define MEDIUM_VERT_SPACING  "2"
#define MEDIUM_FIELD_OFFSET  "6" 
#define MEDIUM_HORIZ_SPACING "4"
#define MEDIUM_DIALOG_VERT_SPACING  "6"
#define MEDIUM_DIALOG_HORIZ_SPACING "6"

#define LARGE_SEARCH_GM "580x365+0+1"  
#define LARGE_SUMM_GM	"880x500+0-0"   
#define LARGE_LIST_GM	"625x375+130+380"  
#define LARGE_FULL_GM	"750x700-0+1"
#define LARGE_HELP_GM   "+70+70"
#define LARGE_DEFAULT_FT "-adobe-helvetica-bold-r*140-75*"
/*#define LARGE_BUTTON_FT  "-adobe-courier-bold-r*140-75*"*/
#define LARGE_BUTTON_FT  "-adobe-helvetica-bold-r*140-75*"
#define LARGE_TEXT_FT    "-adobe-courier-medium-r*140-75*"
#define LARGE_VERT_SPACING  "4"
#define LARGE_FIELD_OFFSET  "7" 
#define LARGE_HORIZ_SPACING "5"
#define LARGE_DIALOG_VERT_SPACING  "8"
#define LARGE_DIALOG_HORIZ_SPACING "8"

#define XLARGE_SEARCH_GM "715x420+0+1"  
#define XLARGE_SUMM_GM	 "1065x580+0-0"    
#define XLARGE_LIST_GM	 "820x470+150+420"  
#define XLARGE_FULL_GM	 "900x795-0+1"
#define XLARGE_HELP_GM   "+70+70"
#define XLARGE_DEFAULT_FT "-adobe-helvetica-bold-r*180-75*"
/*#define XLARGE_BUTTON_FT  "-adobe-courier-bold-r*180-75*"*/
#define XLARGE_BUTTON_FT  "-adobe-helvetica-bold-r*180-75*"
#define XLARGE_TEXT_FT    "-adobe-courier-medium-r*180-75*"
#define XLARGE_VERT_SPACING  "5"
#define XLARGE_FIELD_OFFSET  "7" 
#define XLARGE_HORIZ_SPACING "6"
#define XLARGE_DIALOG_VERT_SPACING  "10"
#define XLARGE_DIALOG_HORIZ_SPACING "10"

#define DEFAULT_SPIN         200
#define DEFAULT_BROWSE_DELAY 250

#define EMACS_BINDINGS "\
  Meta<Key>osfDelete: kill-previous-word()\n\
  Alt<Key>osfDelete:  kill-previous-word()\n\
  Ctrl<Key>D:         delete-next-character() \n\
  Meta<Key>D:         kill-next-word() \n\
  Alt<Key>D:          kill-next-word() \n\
  Ctrl<Key>K:         kill-to-end-of-line() \n\
  Ctrl<Key>U:         kill-to-start-of-line() kill-to-end-of-line() \n\
  Ctrl<Key>W:         kill-selection() \n\
  Ctrl<Key>Y:         unkill() \n\
  Ctrl<Key>F:         forward-character() \n\
  Ctrl<Key>B:         backward-character() \n\
  Ctrl<Key>A:         beginning-of-line() \n\
  Ctrl<Key>E:         end-of-line() \n\
  Meta<Key>F:         forward-word() \n\
  Alt<Key>F:          forward-word() \n\
  Meta<Key>B:         backward-word() \n\
  Alt<Key>B:          backward-word() \n "


/* Define a stupid structure, because Xt forces us to put all of
   our own new resources into a structure for use with 
   XtGetApplicationResources */
typedef struct {
  /* The first group are copied out into the real variables */
  char *willow_dir;
  char *db_config_file_name;
  char *print_cmd;
  char *mail_subj;
  char *mail_addr;
  char *ftp_host;
  char *ftp_uid;
  char *user_info;
  char *custom_fields;
  int   spin_delay;
  int   debug_level;
  int   save_type;
  Boolean enable_cheat;
  int     interface_mode;
  Boolean initial_echo;
  Boolean abbrev_fields;
  Boolean no_basic_mode;
  Boolean ftp_append;
  Boolean show_search;
  Boolean show_print_dialog;
  char *willow_size;
  int   browse_delay;

  /* These are only used in resources.c, and are not 
     copied into real variables */
  char *default_font;
  char *text_font;
  char *button_font;
  char *default_bg;
  char *default_fg;
  char *menubar_bg;
  char *menubar_fg;
  char *text_bg;
  char *text_fg;
  char *image_bg;
  char *image_fg;
  char *button_bg;
  char *button_fg;
  char *field_btn_bg;
  char *field_btn_fg;
  char *check_mark_bg;
  char *save_type_name;
  char *interface_mode_name;
  Boolean inverse;
} OptionsRec;
