/***********************************************************************
 *                                                                     *
 *              WILLOW(tm) Information Retrieval Software              *
 *     (Washington Information Looker-upper Layered Over Windows)      *
 *             Copyright 1992-1994 University of Washington            *
 *                                                                     *
 *   Willow is a trademark of the University of Washington.  No        *
 *   commercial use of this trademark or software may be made without  *
 *   prior written permission of the University of Washington.         *
 *                                                                     *
 * Permission to use, copy, modify, and distribute Willow(tm) software *
 * and its documentation for any noncommercial purpose is hereby       *
 * granted, provided that the above copyright notice appears in all    *
 * copies and that both the above copyright notice and this permission *
 * notice appear in supporting documentation, and that the name of the *
 * University of Washington not be used in advertising or publicity    *
 * pertaining to distribution of the software without specific,        *
 * written prior permission.  This software is made available "as is", *
 * and THE UNIVERSITY OF WASHINGTON DISCLAIMS ALL WARRANTIES, EXPRESS  *
 * OR IMPLIED, WITH REGARD TO THIS SOFTWARE, INCLUDING WITHOUT         *
 * LIMITATION ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS    *
 * FOR A PARTICULAR PURPOSE, AND IN NO EVENT SHALL THE UNIVERSITY OF   *
 * WASHINGTON BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL     *
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA  *
 * OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, TORT (INCLUDING       *
 * NEGLIGENCE) OR STRICT LIABILITY, ARISING OUT OF OR IN CONNECTION    *
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.                       *
 *                                                                     *
 * For further information please contact:                             *
 * Willow Project                                                      *
 * Information Systems                                                 *
 * University of Washington                                            *
 * 4545 15th NE, 1st floor                                             *
 * Seattle, Washington, 98105, USA                                     *
 * Internet: willow@cac.washington.edu                                 *
 ***********************************************************************/

/*******************************************************
 * save_search.h
 * This file contains the declarations for the data 
 * structures needed to store old searches.
 ******************************************************/

/* This is a record which holds the information necessary to reconstruct
   a search when it is selected from the search menu.
 */
typedef struct _search_rec {
  char   *field_names[NUM_TEXT_FIELDS];  /* Names of the fields        */
  char   *text_vals[NUM_TEXT_FIELDS];    /* User-entered strings       */
  char   *bool_names[NUM_BOOL_FIELDS];   /* names for boolean fields   */
  int     bool_vals[NUM_BOOL_FIELDS];    /* Value of bool fields       */
  range_stat_rec *froms[NUM_TEXT_FIELDS];/* Values for From range btns */
  range_stat_rec *tos[NUM_TEXT_FIELDS];  /* Values for To range btns   */
} Search_rec, *Search_ptr; 

/* Various other information needed keep a list of saved searches straight */
typedef struct _search_list_rec {
  Widget  button;
  Search_ptr search;
  XmString name;
  struct _search_list_rec *next;
} Search_list_rec, *Search_list_ptr;

/* Strings used for creating the query display for saved results */
#define QUERY_DISPLAY_HEADER "\n###########################################################################\n\
#    WILLOW SEARCH RESULTS: %s\n\
#             CONNECTED to: %s\n\
#\n"
#define QUERY_DISPLAY_PREFIX "# "
#define QUERY_DISPLAY_FOOTER "\n###########################################################################\n\n"
#define QUERY_DISPLAY_RANGE "FROM %s  TO %s"
#define FIELD_DISP_WID 18
