/***********************************************************************
 *                                                                     *
 *              WILLOW(tm) Information Retrieval Software              *
 *     (Washington Information Looker-upper Layered Over Windows)      *
 *             Copyright 1992-1994 University of Washington            *
 *                                                                     *
 *   Willow is a trademark of the University of Washington.  No        *
 *   commercial use of this trademark or software may be made without  *
 *   prior written permission of the University of Washington.         *
 *                                                                     *
 * Permission to use, copy, modify, and distribute Willow(tm) software *
 * and its documentation for any noncommercial purpose is hereby       *
 * granted, provided that the above copyright notice appears in all    *
 * copies and that both the above copyright notice and this permission *
 * notice appear in supporting documentation, and that the name of the *
 * University of Washington not be used in advertising or publicity    *
 * pertaining to distribution of the software without specific,        *
 * written prior permission.  This software is made available "as is", *
 * and THE UNIVERSITY OF WASHINGTON DISCLAIMS ALL WARRANTIES, EXPRESS  *
 * OR IMPLIED, WITH REGARD TO THIS SOFTWARE, INCLUDING WITHOUT         *
 * LIMITATION ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS    *
 * FOR A PARTICULAR PURPOSE, AND IN NO EVENT SHALL THE UNIVERSITY OF   *
 * WASHINGTON BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL     *
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA  *
 * OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, TORT (INCLUDING       *
 * NEGLIGENCE) OR STRICT LIABILITY, ARISING OUT OF OR IN CONNECTION    *
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.                       *
 *                                                                     *
 * For further information please contact:                             *
 * Willow Project                                                      *
 * Information Systems                                                 *
 * University of Washington                                            *
 * 4545 15th NE, 1st floor                                             *
 * Seattle, Washington, 98105, USA                                     *
 * Internet: willow@cac.washington.edu                                 *
 ***********************************************************************/

/***************************************************
 * text-list.h
 * Declarations for text-list pseudo-widget
 ***************************************************/

#define LIST_CHUNK_ITEMS  256

/* Define the text-list callback types */
#define SELECT_CB       0
#define CLICK2_CB       1
#define SCROLL_UP_CB    2
#define SCROLL_DN_CB    3
#define DESELECT_CB     4
#define DESELECT_ALL_CB 5

typedef struct _list_item {  /* describe an entry in a text list */
  int     offset;
  int     len;     /* this is not really needed, but makes life simple */
  Boolean selected; 
} list_item;

typedef struct _list_rec {  /* describe a list */
  int     num_items;
  int     num_slots;
  int     num_selected;
  int     last_selected;
  int     last_clicked;
  int     last_dragged;
  int     min_dragged;
  int     max_dragged;
  int     len;
  void    (*select_cb)();
  void    (*deselect_cb)();
  void    (*deselect_all_cb)();
  void    (*click2_cb)();
  void    (*scroll_up_cb)();
  void    (*scroll_down_cb)();
  list_item *items;
} list_rec;

typedef struct _list_callback_struct {
  int    pos;
} list_callback_struct;
