/*                           BIB1ATTR.H                              */

/*
 *  Copyright (c) 1992 Stanford Leland Junior University
 *
 *  Commercial use prohibited
 *
 *  Author: Harold Finkbeiner (Harold@Forsythe.Stanford.Edu)
 */

#ifndef BIB1ATTR_H
#define BIB1ATTR_H

#include <stddef.h>

/* Structure description for attribute matching array */

typedef struct attrib_description
{
    char *name;
    int       value;
} ATTRIB_DESC, *ATTRIB_DESC_REF;

static ATTRIB_DESC bib1_structs[] =
{
    {"PHRASE", 1},
    {"WORD", 2},
    {"KEY", 3},
    {"YEAR", 4},
    {"DATE", 5},
    {"WORD_LIST", 6},
    {"WORD_ADJ", 7},
    {"DATE_UNNORM", 100},
    {"NAME", 101},
    {"NAME_UNNORM", 102},
    {"NO_STRUCTURE", 0 }
};

static ATTRIB_DESC bib1_compls[] =
{
    {"ISUB", 1},
    {"CSUB", 2},
    {"CFLD", 3},
    {"NO_COMPLETENESS", 0}
};

static ATTRIB_DESC bib1_poss[] =
{
    {"FF", 1},
    {"FS", 2},
    {"ANY",3},
    {"NO_POSITION", 0}
};

#endif
