/*                            SERVERZ.H                            */

/*
 *  Copyright (c) 1992 Stanford Leland Junior University
 *
 *  Commercial use prohibited
 *
 *  Author: Harold Finkbeiner (Harold@Forsythe.Stanford.Edu)
 */

#ifndef SERVERS_H
#define SERVERS_H

/*
   The following table describes some of the various Z39.50
   servers which can be connected to by just using a name.

   I grew tired of typing in the host name time after time
   and having to type them correctly.
*/

typedef struct select_description
    {
        char *match;
        char *name;
        char *host;
    } SELECT_ENTRY, *SELECT_REFERENCE;

static SELECT_ENTRY select_table[] =
    {
        "MELVYL",      "cat",      "melvyl.ucop.edu",
        "OCLC",        "OLUC",     "rdsd-rs6000.dev.oclc.org",
        "ERIC",        "ERIC",     "rdsd-rs6000.dev.oclc.org",
        "NOTIS",       "ERIC",     "192.101.184.12",
        "IREG",        "IREG",     "192.101.184.12",
        "PENN",        "catalog",  "128.118.88.200",
        "BOOKS",       "books",    "research.att.com",
        "MATHSTAT",    "netlib",   "research.att.com",
        "GAYLORD",     "bib",      "saturn.gaylord.com",
        "RLG",         "BIB",      "rlg.stanford.edu",
        "INFOCAL",     "cat",      "infocal.berkeley.edu",  /* Must be last */
    };

#define select_total ((int) (sizeof(select_table) / sizeof(select_table[0])))

#endif
