/*
 *  Copyright (C) 1994 by the Massachusetts Institute of Technology
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies and that both that copyright notice and this permission
 * notice appear in supporting documentation, and that the name of
 * M.I.T. not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior
 * permission.  M.I.T. makes no representations about the suitability
 * of this software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 */

/* Author: Tom Owens MIT Library Systems Office */
/*
 * 04/18/94  slh  rule data/params (RULEDATA)
 *  ... 04/25/94
 */
#define  RULEDATA	/* DATA/params allowed for RULEs */

/* header file for brief display routines */
#define FULL 1
#define BRIEF 2
#define LABEL_LENGTH 20
#define	USE_DEFAULT_FLAG '|'
#define	SPECIFIC_ORDER_FLAG '!'
#define SPECIAL_RULE_FLAG 'R'
#ifdef   RULEDATA
#define RULE_PARAM_SEP	'!'
#endif /*RULEDATA*/
#define PREFIX_START '{'
#define PREFIX_END '}'
#define SUFFIX_START '<'
#define SUFFIX_END '>'
#define DO_NOT_USE_FLAG '~'
#define NOT_APPLICABLE '#'
#define BLANK_FLAG '&'
#define DOCUMENT_FLAG '/'
#define BLANK ' '
#define BLANK_CODE '@'
#define MIN_TAG_ALLOWED 1
#define MAX_TAG_ALLOWED 999
#define MAX_SUMMARY_SIZE 9999
#define MAX_SUMMARY_DIGITS 4
#define MAX_CHARS_IN_LINE 78
#define BAD_BRIEF -1
#define BAD_FULL -2
#define BAD_BIB -3
#define BRIEF_FILE "bibbrief"
#define FULL_FILE "bibfull"
#define DEFAULT_BIB_DIRECTORY "/mit/library/shared/willow/"
#define TAG_MARK_LEN 3
#ifdef   RULEDATA
#define MAX_FIXED_FIELD	10	/* marc field 010 and below fixed w/o inds. */
#define MAX_RULE	7
#else  /*RULEDATA*/
#define MAX_RULE 2
#define MAX_RULE_LENGTH 1
#endif /*RULEDATA*/
#define USE_SPECIAL_RULE 10000

typedef char *ARRAYS_POINTER;
typedef int (*FUNC_POINTER)();

typedef struct bNode{
    char label[LABEL_LENGTH+1];
    char *tagPrefix;
    int tag;
    char *tagSuffix;
    char *indOne;
    char *indTwo;
    enum {undefined, recordOrder, listedOrder} sfdOrderRule;
/*    ARRAYS_POINTER *sfdPrefixes;
*/
    char *sfds;
/*    ARRAYS_POINTER *sfdSuffixes; */
    enum {unset, use, doNotUse} sfdInclusionRule;
   int (*SpecialRule)();
#ifdef   RULEDATA
  char	*pszRuleData;
#endif /*RULEDATA*/
   int charsInSummary;
    struct bNode *next;
} BIB;


/* prototypes */

#ifdef _STDC_
int MakeBrief(void);
#else
int MakeBrief();
#endif

#ifdef _STDC_
int GetBrief(MARC_RECORD *marc, char **outBrief, char **outSummary);
#else
int GetBrief();
#endif

#ifdef _STDC_
int NewBrief (BRIEF **h, BRIEF **t);
#else
int NewBrief();
#endif

#ifdef _STDC_
void ShowList (BRIEF *h);
#else
void ShowList ();
#endif

#ifdef _STDC_
int AppendChars (char *charArray, int);
#else
int AppendChars();
#endif

#ifdef _STDC_
int MakeDisplayable (char *string, int);
#else
int MakeDisplayable();
#endif

#ifdef _STDC_
int AppendDisplayString (char *string, int);
#else
int AppendDisplayString();
#endif

#ifdef _STDC_
int AppendBySfdOccurrence (char *tagData, int);
#else
int AppendBySfdOccurrence ();
#endif

#ifdef _STDC_
int AppendBySfdName (char *tagData, int);
#else
int AppendBySfdName();
#endif

#ifdef _STDC_
void InsertBlanks(char *string);
#else
void InsertBlanks();
#endif

int BadRule();
int AssignSpecialRule();
void GetSpecialRule();
void MakeRuleTable();

