/***********************************************************************
 *                                                                     *
 *              WILLOW(tm) Information Retrieval Software              *
 *     (Washington Information Looker-upper Layered Over Windows)      *
 *             Copyright 1992-1994 University of Washington            *
 *                                                                     *
 *   Willow is a trademark of the University of Washington.  No        *
 *   commercial use of this trademark or software may be made without  *
 *   prior written permission of the University of Washington.         *
 *                                                                     *
 * Permission to use, copy, modify, and distribute Willow(tm) software *
 * and its documentation for any noncommercial purpose is hereby       *
 * granted, provided that the above copyright notice appears in all    *
 * copies and that both the above copyright notice and this permission *
 * notice appear in supporting documentation, and that the name of the *
 * University of Washington not be used in advertising or publicity    *
 * pertaining to distribution of the software without specific,        *
 * written prior permission.  This software is made available "as is", *
 * and THE UNIVERSITY OF WASHINGTON DISCLAIMS ALL WARRANTIES, EXPRESS  *
 * OR IMPLIED, WITH REGARD TO THIS SOFTWARE, INCLUDING WITHOUT         *
 * LIMITATION ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS    *
 * FOR A PARTICULAR PURPOSE, AND IN NO EVENT SHALL THE UNIVERSITY OF   *
 * WASHINGTON BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL     *
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA  *
 * OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, TORT (INCLUDING       *
 * NEGLIGENCE) OR STRICT LIABILITY, ARISING OUT OF OR IN CONNECTION    *
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.                       *
 *                                                                     *
 * For further information please contact:                             *
 * Willow Project                                                      *
 * Information Systems                                                 *
 * University of Washington                                            *
 * 4545 15th NE, 1st floor                                             *
 * Seattle, Washington, 98105, USA                                     *
 * Internet: willow@cac.washington.edu                                 *
 ***********************************************************************/

/*****************************************************
 * host.h
 *
 *****************************************************/

#define NO_CON          0

/* Table of extra characters which should be considered part of a word. */
static char valid_extra_chars[] =
                      {' ',
		      '\0',
		      '-',  /* word-joiner */
		      '$',  /* wild-card chars */
		      '?',
		      '\t',
		      '_',  /* Not in some isalpha impls */
};

#define SUMM_VIS_SEP    '+'
#define SUMM_INVIS_SEP  '-'
#define SUMM_FIELD_SEP  ','

/* The second of these must be multiple of the first */
#define SUMM_BLOCK_SIZE         30
#define SUMM_ALLOC_SIZE         300
#define ABBREV_INDENT           5
#define DFLT_LONG_LEN           16
#define MAX_SUMM_FIELD_NAME_LEN 32
#define MAX_DISP_LINE           78
#define DFLT_CIRC_TIMEOUT       90

/* format description for the summary fields */
typedef struct format_rec {
    char lname[40];
    int  width;
    int  count;
    char flag;
} FORMAT_RECORD;

/* Prototypes */
FORMAT_RECORD *tag_from_table(char *string,
			      FORMAT_RECORD *entry,
			      int table_count);

void tags_into_table(char *tags,
		     FORMAT_RECORD *table,
		     int *table_count);
