
/*  --------------------  STRINGLIST (strlst) ---------------- */
/* implements a simple linked list of terms/occurrences and some
   associated functions */

typedef struct stringlist_item
{
    char *item;
    int occurrences;
    struct stringlist_item *next;
} STRLST_ITEM;

typedef struct strlst
{
    int numitems;
    STRLST_ITEM *head;
} STRLST;


/* constants for collating sequences */
#define ASCII_COLLATING 1
#define EBCDIC_COLLATING 2


/*prototypes*/

STRLST *strlst_new();
int strlst_get_numitems(STRLST *sl);
char *strlst_get_item(STRLST *sl, int i);
int strlst_get_occurrences(STRLST *sl, int i);
int strlst_set_item(STRLST *sl, int i, char *item, int occurrences);
int strlst_insert(STRLST *sl, int i, char *item, int occurrences);
int strlst_remove(STRLST *sl, int i);
int strlst_dispose(STRLST **psl);
int strlst_combine(STRLST *sl1, STRLST **psl2);
void strlst_display(STRLST *sl);
int strlst_get_position(STRLST *sl, char *item, int collate);
STRLST *series2strlst(SERIES *ser);
SERIES *strlst2series(STRLST *sl);
int strlst_prune_list(STRLST *sl, int i);
