
//
//    X SHARE MANAGER (XSM)
//
//    Copyright (C) 1995  David Simons
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//
// $Id: textdialog.h,v 2.3 1995/06/24 15:06:13 davidsi Exp $
//
// $Log: textdialog.h,v $
// Revision 2.3  1995/06/24  15:06:13  davidsi
// - Added GNU copyright message.
//
// Revision 2.2  1995/04/16  20:25:48  davidsi
// - Added TextdialogSetprintertitle() that allows a title to be set that
//   will be used when printing out.
//
// Revision 2.1  1995/03/01  22:18:24  davidsi
// - Add TextdialogRedraw() to allow a forced update - useful if
//   the fundamental data to be displayed changes.
// - The Textdialog class now inherits from the Colour class.
// - BUG FIX. Textdialogprint() requires a destructor so that it can
//   delete the Drawtext instance.
//
// Revision 2.0  1995/02/02  21:18:35  davidsi
// - Initial version.
//
//
//
#ifndef __TEXTDIALOG_H
#define __TEXTDIALOG_H

#include "suplib.h"
#include "menu.h"
#include "drawtext.h"
#include "printer.h"
#include "colour.h"


//
// The Textdialog class
//
class Textdialog : public Text, public Menu, public Colour {
	dialog ti_ptr;			// text info for text
	menu_bar *add_mb;		// menu bar to use or NULL
	class Drawtext *dt;		// the draw text 
	class Textdialogprint *printer;

private:
	static void accessfield(char *rthis,int l,int f,char **string,int *len,char **col,int *fattr);

protected:
	char *title;			// name of window
	char *printer_title;

	void TextdialogSettitle(char *title);
	void TextdialogSetprintertitle(char *ptitle);
public:
	void TextdialogOutput();
	void TextdialogPrint();
	void TextdialogRedraw();

	Textdialog();
	~Textdialog();

friend Textdialogprint;
};

#endif
