.TH xephem 1X
.SH Name
xephem \- an interactive astronomical ephemeris for X
.SH Syntax
\fBxephem\fP
.SH Description
.PP
.B Xephem
is an interactive astronomical ephemeris program for X Windows. It has built-in
support for all planets plus support for arbitrary objects given their
heliocentric orbital elements. Xephem generates tabular and graphical schematic
views of the sky and solar system objects, can plot and list data, and
can search for arbitrary user-defined circumstances.

Xephem contains extensive context-senstive on-line help. Virtually none of that
help is duplicated here so go ahead and run xephem to learn more. In order for
xephem to find this help text the resource `XEphem.HELPFILE' must be set to the
pathname of the xephem.hlp file.

.SH Main Menu
.PP
The main menu of
.B xephem
provides control and display of three basic services: observing circumstances,
looping, and access to additional displays.

Observing circumstances includes location, time and atmospheric conditions
(used for the refraction model). Looping refers to the ability to set
.B xephem
so that it automatically increments time and a desired step size and rate.
The additional displays provide all of the tabular and graphical information
available, and always refer to the circumstances defined in the main menu.
The additional displays are activated from the 
.I Views
pulldown.

.B Xephem
has information about the Solar system planets and several moons
built in. These can be accessed without the need to access an external
database. However, if a database of objects is available then
.B xephem
can read this information into memory and use it as well. The database
is read in using the
.I DB...
pulldown. The objects may be inspected in detail, manipulated and assigned
to so-called `user defined objects' X and Y using the
.I ObjX/Y...
pulldown.

All of the tabular data that 
.B xephem
presents can be written to a file and later plotted, written in a tabular
listing, or used to formulate an arbitrary mathematical expression that can
be solved for a maximum, minimum or zero. All of these facilities are
accessed from the
.I Control
pulldown.

Several display and accuracy formating options may be controlled from the
.I Preferences
pulldown.

Finally, the
.I Help
pulldown provides several categories of assistance applicable to the overall
operation of
.B xephem.
Beginners might start by reading the 
.I Introduction
help section.

.SH Resources
.PP
XEphem has many resources, many of which you will soon want to tune to your
taste and circumstances; many others may be left unchanged. Look through the
XEphem.ad distribution for full details.

Of course, in addition to all the custom resources, xephem supports
the usual Xt resources such as -display, -xrm, -fg and -bg.

The application class of xephem is XEphem.

A list of widgets in xephem would be enormous. If you really want such
a list, build xephem for X11R5 and use the editres feature. The necessary
code is in xephem.c surrounded by #ifdef WANT_EDITRES.
.SH Author
.PP
Elwood Downey, currently at ecdowney@pobox.cca.cr.rockwell.com
.SH See also
.PP
Ephem, the ancestor of xephem suitable for "dumb" 24x80 character displays,
including VMS and DOS as well as UNIX.
.PP
Ephem and xephem are both on export.lcs.mit.edu; look for contrib/ephem*
and contrib/xephem* for the latest releases.
